/* EvaluationResult.c generated by valac 0.53.2, the Vala compiler
 * generated from EvaluationResult.vala, do not modify */

/*-
 * Copyright (c) 2017-2020 Subhadeep Jasu <subhajasu@gmail.com>
 * Copyright (c) 2017-2020 Saunak Biswas <saunakbis97@gmail.com>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation; either
 * version 3 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License 
 * along with this program. If not, see <https://www.gnu.org/licenses/>.
 *
 * Authored by: Subhadeep Jasu <subhajasu@gmail.com>
 *              Saunak Biswas  <saunakbis97@gmail.com>
 */

#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <float.h>
#include <math.h>
#include <gobject/gvaluecollector.h>

#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define PEBBLES_TYPE_EVALUATION_RESULT (pebbles_evaluation_result_get_type ())
#define PEBBLES_EVALUATION_RESULT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), PEBBLES_TYPE_EVALUATION_RESULT, PebblesEvaluationResult))
#define PEBBLES_EVALUATION_RESULT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), PEBBLES_TYPE_EVALUATION_RESULT, PebblesEvaluationResultClass))
#define PEBBLES_IS_EVALUATION_RESULT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), PEBBLES_TYPE_EVALUATION_RESULT))
#define PEBBLES_IS_EVALUATION_RESULT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), PEBBLES_TYPE_EVALUATION_RESULT))
#define PEBBLES_EVALUATION_RESULT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), PEBBLES_TYPE_EVALUATION_RESULT, PebblesEvaluationResultClass))

typedef struct _PebblesEvaluationResult PebblesEvaluationResult;
typedef struct _PebblesEvaluationResultClass PebblesEvaluationResultClass;
typedef struct _PebblesEvaluationResultPrivate PebblesEvaluationResultPrivate;
typedef enum  {
	PEBBLES_GLOBAL_ANGLE_UNIT_DEG = 0,
	PEBBLES_GLOBAL_ANGLE_UNIT_RAD = 1,
	PEBBLES_GLOBAL_ANGLE_UNIT_GRAD = 2
} PebblesGlobalAngleUnit;

#define PEBBLES_TYPE_GLOBAL_ANGLE_UNIT (pebbles_global_angle_unit_get_type ())
typedef enum  {
	PEBBLES_EVALUATION_RESULT_CALCULUS_RESULT_MODE_NONE,
	PEBBLES_EVALUATION_RESULT_CALCULUS_RESULT_MODE_INT,
	PEBBLES_EVALUATION_RESULT_CALCULUS_RESULT_MODE_DER
} PebblesEvaluationResultCalculusResultMode;

#define PEBBLES_EVALUATION_RESULT_TYPE_CALCULUS_RESULT_MODE (pebbles_evaluation_result_calculus_result_mode_get_type ())
typedef enum  {
	PEBBLES_EVALUATION_RESULT_RESULT_SOURCE_SCIF,
	PEBBLES_EVALUATION_RESULT_RESULT_SOURCE_CALC,
	PEBBLES_EVALUATION_RESULT_RESULT_SOURCE_PROG
} PebblesEvaluationResultResultSource;

#define PEBBLES_EVALUATION_RESULT_TYPE_RESULT_SOURCE (pebbles_evaluation_result_result_source_get_type ())

#define PEBBLES_PROGRAMMER_CALCULATOR_TYPE_TOKEN (pebbles_programmer_calculator_token_get_type ())
typedef struct _PebblesProgrammerCalculatorToken PebblesProgrammerCalculatorToken;
typedef enum  {
	PEBBLES_PROGRAMMER_CALCULATOR_TOKEN_TYPE_OPERATOR,
	PEBBLES_PROGRAMMER_CALCULATOR_TOKEN_TYPE_OPERAND,
	PEBBLES_PROGRAMMER_CALCULATOR_TOKEN_TYPE_PARENTHESIS
} PebblesProgrammerCalculatorTokenType;

#define PEBBLES_PROGRAMMER_CALCULATOR_TYPE_TOKEN_TYPE (pebbles_programmer_calculator_token_type_get_type ())
typedef enum  {
	PEBBLES_NUMBER_SYSTEM_BINARY,
	PEBBLES_NUMBER_SYSTEM_OCTAL,
	PEBBLES_NUMBER_SYSTEM_DECIMAL,
	PEBBLES_NUMBER_SYSTEM_HEXADECIMAL
} PebblesNumberSystem;

#define PEBBLES_TYPE_NUMBER_SYSTEM (pebbles_number_system_get_type ())
typedef enum  {
	PEBBLES_GLOBAL_WORD_LENGTH_QWD = 0,
	PEBBLES_GLOBAL_WORD_LENGTH_DWD = 1,
	PEBBLES_GLOBAL_WORD_LENGTH_WRD = 2,
	PEBBLES_GLOBAL_WORD_LENGTH_BYT = 3
} PebblesGlobalWordLength;

#define PEBBLES_TYPE_GLOBAL_WORD_LENGTH (pebbles_global_word_length_get_type ())
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _PebblesParamSpecEvaluationResult PebblesParamSpecEvaluationResult;

struct _PebblesEvaluationResult {
	GTypeInstance parent_instance;
	volatile int ref_count;
	PebblesEvaluationResultPrivate * priv;
};

struct _PebblesEvaluationResultClass {
	GTypeClass parent_class;
	void (*finalize) (PebblesEvaluationResult *self);
};

struct _PebblesProgrammerCalculatorToken {
	gchar* token;
	PebblesProgrammerCalculatorTokenType type;
	PebblesNumberSystem number_system;
};

struct _PebblesEvaluationResultPrivate {
	gchar* _problem_expression;
	gchar* _result;
	PebblesGlobalAngleUnit _angle_mode;
	PebblesEvaluationResultCalculusResultMode _calc_mode;
	gdouble _int_limit_a;
	gdouble _int_limit_b;
	gdouble _derivative_point;
	PebblesEvaluationResultResultSource _result_source;
	PebblesProgrammerCalculatorToken* _problem_expression_prog;
	gint _problem_expression_prog_length1;
	gint __problem_expression_prog_size_;
	gboolean* _prog_output;
	gint _prog_output_length1;
	gint __prog_output_size_;
	PebblesGlobalWordLength _word_length;
	PebblesNumberSystem _number_system;
};

struct _PebblesParamSpecEvaluationResult {
	GParamSpec parent_instance;
};

static gint PebblesEvaluationResult_private_offset;
static gpointer pebbles_evaluation_result_parent_class = NULL;

VALA_EXTERN gpointer pebbles_evaluation_result_ref (gpointer instance);
VALA_EXTERN void pebbles_evaluation_result_unref (gpointer instance);
VALA_EXTERN GParamSpec* pebbles_param_spec_evaluation_result (const gchar* name,
                                                  const gchar* nick,
                                                  const gchar* blurb,
                                                  GType object_type,
                                                  GParamFlags flags);
VALA_EXTERN void pebbles_value_set_evaluation_result (GValue* value,
                                          gpointer v_object);
VALA_EXTERN void pebbles_value_take_evaluation_result (GValue* value,
                                           gpointer v_object);
VALA_EXTERN gpointer pebbles_value_get_evaluation_result (const GValue* value);
VALA_EXTERN GType pebbles_evaluation_result_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (PebblesEvaluationResult, pebbles_evaluation_result_unref)
VALA_EXTERN GType pebbles_global_angle_unit_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GType pebbles_evaluation_result_calculus_result_mode_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GType pebbles_evaluation_result_result_source_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GType pebbles_programmer_calculator_token_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GType pebbles_programmer_calculator_token_type_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GType pebbles_number_system_get_type (void) G_GNUC_CONST ;
VALA_EXTERN PebblesProgrammerCalculatorToken* pebbles_programmer_calculator_token_dup (const PebblesProgrammerCalculatorToken* self);
VALA_EXTERN void pebbles_programmer_calculator_token_free (PebblesProgrammerCalculatorToken* self);
VALA_EXTERN void pebbles_programmer_calculator_token_copy (const PebblesProgrammerCalculatorToken* self,
                                               PebblesProgrammerCalculatorToken* dest);
VALA_EXTERN void pebbles_programmer_calculator_token_destroy (PebblesProgrammerCalculatorToken* self);
VALA_EXTERN GType pebbles_global_word_length_get_type (void) G_GNUC_CONST ;
static void _vala_PebblesProgrammerCalculatorToken_array_free (PebblesProgrammerCalculatorToken * array,
                                                        gssize array_length);
VALA_EXTERN PebblesEvaluationResult* pebbles_evaluation_result_new (const gchar* problem_expression,
                                                        const gchar* _result_,
                                                        PebblesGlobalAngleUnit* angle_mode,
                                                        PebblesEvaluationResultCalculusResultMode* calc_mode,
                                                        gdouble* int_limit_a,
                                                        gdouble* int_limit_b,
                                                        gdouble* derivative_point,
                                                        PebblesEvaluationResultResultSource* result_source,
                                                        PebblesProgrammerCalculatorToken* problem_expression_prog,
                                                        gint problem_expression_prog_length1,
                                                        gboolean* prog_output,
                                                        gint prog_output_length1,
                                                        PebblesGlobalWordLength* word_length,
                                                        PebblesNumberSystem* number_system);
VALA_EXTERN PebblesEvaluationResult* pebbles_evaluation_result_construct (GType object_type,
                                                              const gchar* problem_expression,
                                                              const gchar* _result_,
                                                              PebblesGlobalAngleUnit* angle_mode,
                                                              PebblesEvaluationResultCalculusResultMode* calc_mode,
                                                              gdouble* int_limit_a,
                                                              gdouble* int_limit_b,
                                                              gdouble* derivative_point,
                                                              PebblesEvaluationResultResultSource* result_source,
                                                              PebblesProgrammerCalculatorToken* problem_expression_prog,
                                                              gint problem_expression_prog_length1,
                                                              gboolean* prog_output,
                                                              gint prog_output_length1,
                                                              PebblesGlobalWordLength* word_length,
                                                              PebblesNumberSystem* number_system);
static PebblesProgrammerCalculatorToken* _vala_array_dup14 (PebblesProgrammerCalculatorToken* self,
                                                     gssize length);
static gboolean* _vala_array_dup15 (gboolean* self,
                             gssize length);
VALA_EXTERN const gchar* pebbles_evaluation_result_get_problem_expression (PebblesEvaluationResult* self);
VALA_EXTERN void pebbles_evaluation_result_set_problem_expression (PebblesEvaluationResult* self,
                                                       const gchar* value);
VALA_EXTERN const gchar* pebbles_evaluation_result_get_result (PebblesEvaluationResult* self);
VALA_EXTERN void pebbles_evaluation_result_set_result (PebblesEvaluationResult* self,
                                           const gchar* value);
VALA_EXTERN PebblesGlobalAngleUnit pebbles_evaluation_result_get_angle_mode (PebblesEvaluationResult* self);
VALA_EXTERN void pebbles_evaluation_result_set_angle_mode (PebblesEvaluationResult* self,
                                               PebblesGlobalAngleUnit value);
VALA_EXTERN PebblesEvaluationResultCalculusResultMode pebbles_evaluation_result_get_calc_mode (PebblesEvaluationResult* self);
VALA_EXTERN void pebbles_evaluation_result_set_calc_mode (PebblesEvaluationResult* self,
                                              PebblesEvaluationResultCalculusResultMode value);
VALA_EXTERN gdouble pebbles_evaluation_result_get_int_limit_a (PebblesEvaluationResult* self);
VALA_EXTERN void pebbles_evaluation_result_set_int_limit_a (PebblesEvaluationResult* self,
                                                gdouble value);
VALA_EXTERN gdouble pebbles_evaluation_result_get_int_limit_b (PebblesEvaluationResult* self);
VALA_EXTERN void pebbles_evaluation_result_set_int_limit_b (PebblesEvaluationResult* self,
                                                gdouble value);
VALA_EXTERN gdouble pebbles_evaluation_result_get_derivative_point (PebblesEvaluationResult* self);
VALA_EXTERN void pebbles_evaluation_result_set_derivative_point (PebblesEvaluationResult* self,
                                                     gdouble value);
VALA_EXTERN PebblesEvaluationResultResultSource pebbles_evaluation_result_get_result_source (PebblesEvaluationResult* self);
VALA_EXTERN void pebbles_evaluation_result_set_result_source (PebblesEvaluationResult* self,
                                                  PebblesEvaluationResultResultSource value);
VALA_EXTERN PebblesProgrammerCalculatorToken* pebbles_evaluation_result_get_problem_expression_prog (PebblesEvaluationResult* self,
                                                                                         gint* result_length1);
VALA_EXTERN void pebbles_evaluation_result_set_problem_expression_prog (PebblesEvaluationResult* self,
                                                            PebblesProgrammerCalculatorToken* value,
                                                            gint value_length1);
static PebblesProgrammerCalculatorToken* _vala_array_dup16 (PebblesProgrammerCalculatorToken* self,
                                                     gssize length);
VALA_EXTERN gboolean* pebbles_evaluation_result_get_prog_output (PebblesEvaluationResult* self,
                                                     gint* result_length1);
VALA_EXTERN void pebbles_evaluation_result_set_prog_output (PebblesEvaluationResult* self,
                                                gboolean* value,
                                                gint value_length1);
static gboolean* _vala_array_dup17 (gboolean* self,
                             gssize length);
VALA_EXTERN PebblesGlobalWordLength pebbles_evaluation_result_get_word_length (PebblesEvaluationResult* self);
VALA_EXTERN void pebbles_evaluation_result_set_word_length (PebblesEvaluationResult* self,
                                                PebblesGlobalWordLength value);
VALA_EXTERN PebblesNumberSystem pebbles_evaluation_result_get_number_system (PebblesEvaluationResult* self);
VALA_EXTERN void pebbles_evaluation_result_set_number_system (PebblesEvaluationResult* self,
                                                  PebblesNumberSystem value);
static void pebbles_evaluation_result_finalize (PebblesEvaluationResult * obj);
static GType pebbles_evaluation_result_get_type_once (void);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

static inline gpointer
pebbles_evaluation_result_get_instance_private (PebblesEvaluationResult* self)
{
	return G_STRUCT_MEMBER_P (self, PebblesEvaluationResult_private_offset);
}

static GType
pebbles_evaluation_result_result_source_get_type_once (void)
{
	static const GEnumValue values[] = {{PEBBLES_EVALUATION_RESULT_RESULT_SOURCE_SCIF, "PEBBLES_EVALUATION_RESULT_RESULT_SOURCE_SCIF", "scif"}, {PEBBLES_EVALUATION_RESULT_RESULT_SOURCE_CALC, "PEBBLES_EVALUATION_RESULT_RESULT_SOURCE_CALC", "calc"}, {PEBBLES_EVALUATION_RESULT_RESULT_SOURCE_PROG, "PEBBLES_EVALUATION_RESULT_RESULT_SOURCE_PROG", "prog"}, {0, NULL, NULL}};
	GType pebbles_evaluation_result_result_source_type_id;
	pebbles_evaluation_result_result_source_type_id = g_enum_register_static ("PebblesEvaluationResultResultSource", values);
	return pebbles_evaluation_result_result_source_type_id;
}

GType
pebbles_evaluation_result_result_source_get_type (void)
{
	static volatile gsize pebbles_evaluation_result_result_source_type_id__volatile = 0;
	if (g_once_init_enter (&pebbles_evaluation_result_result_source_type_id__volatile)) {
		GType pebbles_evaluation_result_result_source_type_id;
		pebbles_evaluation_result_result_source_type_id = pebbles_evaluation_result_result_source_get_type_once ();
		g_once_init_leave (&pebbles_evaluation_result_result_source_type_id__volatile, pebbles_evaluation_result_result_source_type_id);
	}
	return pebbles_evaluation_result_result_source_type_id__volatile;
}

static GType
pebbles_evaluation_result_calculus_result_mode_get_type_once (void)
{
	static const GEnumValue values[] = {{PEBBLES_EVALUATION_RESULT_CALCULUS_RESULT_MODE_NONE, "PEBBLES_EVALUATION_RESULT_CALCULUS_RESULT_MODE_NONE", "none"}, {PEBBLES_EVALUATION_RESULT_CALCULUS_RESULT_MODE_INT, "PEBBLES_EVALUATION_RESULT_CALCULUS_RESULT_MODE_INT", "int"}, {PEBBLES_EVALUATION_RESULT_CALCULUS_RESULT_MODE_DER, "PEBBLES_EVALUATION_RESULT_CALCULUS_RESULT_MODE_DER", "der"}, {0, NULL, NULL}};
	GType pebbles_evaluation_result_calculus_result_mode_type_id;
	pebbles_evaluation_result_calculus_result_mode_type_id = g_enum_register_static ("PebblesEvaluationResultCalculusResultMode", values);
	return pebbles_evaluation_result_calculus_result_mode_type_id;
}

GType
pebbles_evaluation_result_calculus_result_mode_get_type (void)
{
	static volatile gsize pebbles_evaluation_result_calculus_result_mode_type_id__volatile = 0;
	if (g_once_init_enter (&pebbles_evaluation_result_calculus_result_mode_type_id__volatile)) {
		GType pebbles_evaluation_result_calculus_result_mode_type_id;
		pebbles_evaluation_result_calculus_result_mode_type_id = pebbles_evaluation_result_calculus_result_mode_get_type_once ();
		g_once_init_leave (&pebbles_evaluation_result_calculus_result_mode_type_id__volatile, pebbles_evaluation_result_calculus_result_mode_type_id);
	}
	return pebbles_evaluation_result_calculus_result_mode_type_id__volatile;
}

static void
_vala_PebblesProgrammerCalculatorToken_array_free (PebblesProgrammerCalculatorToken * array,
                                                   gssize array_length)
{
	if (array != NULL) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			pebbles_programmer_calculator_token_destroy (&array[i]);
		}
	}
	g_free (array);
}

static PebblesProgrammerCalculatorToken*
_vala_array_dup14 (PebblesProgrammerCalculatorToken* self,
                   gssize length)
{
	if (length > 0) {
		PebblesProgrammerCalculatorToken* result;
		gssize i;
		result = g_new0 (PebblesProgrammerCalculatorToken, length);
		for (i = 0; i < length; i++) {
			PebblesProgrammerCalculatorToken _tmp0_;
			PebblesProgrammerCalculatorToken _tmp1_ = {0};
			_tmp0_ = self[i];
			pebbles_programmer_calculator_token_copy (&_tmp0_, &_tmp1_);
			result[i] = _tmp1_;
		}
		return result;
	}
	return NULL;
}

static gboolean*
_vala_array_dup15 (gboolean* self,
                   gssize length)
{
	if (length > 0) {
		return _vala_memdup2 (self, length * sizeof (gboolean));
	}
	return NULL;
}

PebblesEvaluationResult*
pebbles_evaluation_result_construct (GType object_type,
                                     const gchar* problem_expression,
                                     const gchar* _result_,
                                     PebblesGlobalAngleUnit* angle_mode,
                                     PebblesEvaluationResultCalculusResultMode* calc_mode,
                                     gdouble* int_limit_a,
                                     gdouble* int_limit_b,
                                     gdouble* derivative_point,
                                     PebblesEvaluationResultResultSource* result_source,
                                     PebblesProgrammerCalculatorToken* problem_expression_prog,
                                     gint problem_expression_prog_length1,
                                     gboolean* prog_output,
                                     gint prog_output_length1,
                                     PebblesGlobalWordLength* word_length,
                                     PebblesNumberSystem* number_system)
{
	PebblesEvaluationResult* self = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	g_return_val_if_fail (problem_expression != NULL, NULL);
	g_return_val_if_fail (_result_ != NULL, NULL);
	self = (PebblesEvaluationResult*) g_type_create_instance (object_type);
	_tmp0_ = g_strdup (problem_expression);
	_g_free0 (self->priv->_problem_expression);
	self->priv->_problem_expression = _tmp0_;
	_tmp1_ = g_strdup (_result_);
	_g_free0 (self->priv->_result);
	self->priv->_result = _tmp1_;
	if (angle_mode != NULL) {
		self->priv->_angle_mode = *angle_mode;
	}
	if (calc_mode != NULL) {
		self->priv->_calc_mode = *calc_mode;
	}
	if (int_limit_a != NULL) {
		self->priv->_int_limit_a = *int_limit_a;
	}
	if (int_limit_b != NULL) {
		self->priv->_int_limit_b = *int_limit_b;
	}
	if (derivative_point != NULL) {
		self->priv->_derivative_point = *derivative_point;
	}
	if (result_source != NULL) {
		self->priv->_result_source = *result_source;
	}
	if (problem_expression_prog != NULL) {
		PebblesProgrammerCalculatorToken* _tmp2_;
		gint _tmp2__length1;
		_tmp2_ = (problem_expression_prog != NULL) ? _vala_array_dup14 (problem_expression_prog, problem_expression_prog_length1) : problem_expression_prog;
		_tmp2__length1 = problem_expression_prog_length1;
		self->priv->_problem_expression_prog = (_vala_PebblesProgrammerCalculatorToken_array_free (self->priv->_problem_expression_prog, self->priv->_problem_expression_prog_length1), NULL);
		self->priv->_problem_expression_prog = _tmp2_;
		self->priv->_problem_expression_prog_length1 = _tmp2__length1;
		self->priv->__problem_expression_prog_size_ = self->priv->_problem_expression_prog_length1;
	}
	if (prog_output != NULL) {
		gboolean* _tmp3_;
		gint _tmp3__length1;
		_tmp3_ = (prog_output != NULL) ? _vala_array_dup15 (prog_output, prog_output_length1) : prog_output;
		_tmp3__length1 = prog_output_length1;
		self->priv->_prog_output = (g_free (self->priv->_prog_output), NULL);
		self->priv->_prog_output = _tmp3_;
		self->priv->_prog_output_length1 = _tmp3__length1;
		self->priv->__prog_output_size_ = self->priv->_prog_output_length1;
	}
	self->priv->_word_length = *word_length;
	self->priv->_number_system = *number_system;
	return self;
}

PebblesEvaluationResult*
pebbles_evaluation_result_new (const gchar* problem_expression,
                               const gchar* _result_,
                               PebblesGlobalAngleUnit* angle_mode,
                               PebblesEvaluationResultCalculusResultMode* calc_mode,
                               gdouble* int_limit_a,
                               gdouble* int_limit_b,
                               gdouble* derivative_point,
                               PebblesEvaluationResultResultSource* result_source,
                               PebblesProgrammerCalculatorToken* problem_expression_prog,
                               gint problem_expression_prog_length1,
                               gboolean* prog_output,
                               gint prog_output_length1,
                               PebblesGlobalWordLength* word_length,
                               PebblesNumberSystem* number_system)
{
	return pebbles_evaluation_result_construct (PEBBLES_TYPE_EVALUATION_RESULT, problem_expression, _result_, angle_mode, calc_mode, int_limit_a, int_limit_b, derivative_point, result_source, problem_expression_prog, problem_expression_prog_length1, prog_output, prog_output_length1, word_length, number_system);
}

const gchar*
pebbles_evaluation_result_get_problem_expression (PebblesEvaluationResult* self)
{
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_problem_expression;
	result = _tmp0_;
	return result;
}

void
pebbles_evaluation_result_set_problem_expression (PebblesEvaluationResult* self,
                                                  const gchar* value)
{
	gchar* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = g_strdup (value);
	_g_free0 (self->priv->_problem_expression);
	self->priv->_problem_expression = _tmp0_;
}

const gchar*
pebbles_evaluation_result_get_result (PebblesEvaluationResult* self)
{
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_result;
	result = _tmp0_;
	return result;
}

void
pebbles_evaluation_result_set_result (PebblesEvaluationResult* self,
                                      const gchar* value)
{
	gchar* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = g_strdup (value);
	_g_free0 (self->priv->_result);
	self->priv->_result = _tmp0_;
}

PebblesGlobalAngleUnit
pebbles_evaluation_result_get_angle_mode (PebblesEvaluationResult* self)
{
	PebblesGlobalAngleUnit result;
	PebblesGlobalAngleUnit _tmp0_;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->_angle_mode;
	result = _tmp0_;
	return result;
}

void
pebbles_evaluation_result_set_angle_mode (PebblesEvaluationResult* self,
                                          PebblesGlobalAngleUnit value)
{
	g_return_if_fail (self != NULL);
	self->priv->_angle_mode = value;
}

PebblesEvaluationResultCalculusResultMode
pebbles_evaluation_result_get_calc_mode (PebblesEvaluationResult* self)
{
	PebblesEvaluationResultCalculusResultMode result;
	PebblesEvaluationResultCalculusResultMode _tmp0_;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->_calc_mode;
	result = _tmp0_;
	return result;
}

void
pebbles_evaluation_result_set_calc_mode (PebblesEvaluationResult* self,
                                         PebblesEvaluationResultCalculusResultMode value)
{
	g_return_if_fail (self != NULL);
	self->priv->_calc_mode = value;
}

gdouble
pebbles_evaluation_result_get_int_limit_a (PebblesEvaluationResult* self)
{
	gdouble result;
	g_return_val_if_fail (self != NULL, 0.0);
	result = self->priv->_int_limit_a;
	return result;
}

void
pebbles_evaluation_result_set_int_limit_a (PebblesEvaluationResult* self,
                                           gdouble value)
{
	g_return_if_fail (self != NULL);
	self->priv->_int_limit_a = value;
}

gdouble
pebbles_evaluation_result_get_int_limit_b (PebblesEvaluationResult* self)
{
	gdouble result;
	g_return_val_if_fail (self != NULL, 0.0);
	result = self->priv->_int_limit_b;
	return result;
}

void
pebbles_evaluation_result_set_int_limit_b (PebblesEvaluationResult* self,
                                           gdouble value)
{
	g_return_if_fail (self != NULL);
	self->priv->_int_limit_b = value;
}

gdouble
pebbles_evaluation_result_get_derivative_point (PebblesEvaluationResult* self)
{
	gdouble result;
	g_return_val_if_fail (self != NULL, 0.0);
	result = self->priv->_derivative_point;
	return result;
}

void
pebbles_evaluation_result_set_derivative_point (PebblesEvaluationResult* self,
                                                gdouble value)
{
	g_return_if_fail (self != NULL);
	self->priv->_derivative_point = value;
}

PebblesEvaluationResultResultSource
pebbles_evaluation_result_get_result_source (PebblesEvaluationResult* self)
{
	PebblesEvaluationResultResultSource result;
	PebblesEvaluationResultResultSource _tmp0_;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->_result_source;
	result = _tmp0_;
	return result;
}

void
pebbles_evaluation_result_set_result_source (PebblesEvaluationResult* self,
                                             PebblesEvaluationResultResultSource value)
{
	g_return_if_fail (self != NULL);
	self->priv->_result_source = value;
}

PebblesProgrammerCalculatorToken*
pebbles_evaluation_result_get_problem_expression_prog (PebblesEvaluationResult* self,
                                                       gint* result_length1)
{
	PebblesProgrammerCalculatorToken* result;
	PebblesProgrammerCalculatorToken* _tmp0_;
	gint _tmp0__length1;
	PebblesProgrammerCalculatorToken* _tmp1_;
	gint _tmp1__length1;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_problem_expression_prog;
	_tmp0__length1 = self->priv->_problem_expression_prog_length1;
	_tmp1_ = _tmp0_;
	_tmp1__length1 = _tmp0__length1;
	if (result_length1) {
		*result_length1 = _tmp1__length1;
	}
	result = _tmp1_;
	return result;
}

static PebblesProgrammerCalculatorToken*
_vala_array_dup16 (PebblesProgrammerCalculatorToken* self,
                   gssize length)
{
	if (length > 0) {
		PebblesProgrammerCalculatorToken* result;
		gssize i;
		result = g_new0 (PebblesProgrammerCalculatorToken, length);
		for (i = 0; i < length; i++) {
			PebblesProgrammerCalculatorToken _tmp0_;
			PebblesProgrammerCalculatorToken _tmp1_ = {0};
			_tmp0_ = self[i];
			pebbles_programmer_calculator_token_copy (&_tmp0_, &_tmp1_);
			result[i] = _tmp1_;
		}
		return result;
	}
	return NULL;
}

void
pebbles_evaluation_result_set_problem_expression_prog (PebblesEvaluationResult* self,
                                                       PebblesProgrammerCalculatorToken* value,
                                                       gint value_length1)
{
	PebblesProgrammerCalculatorToken* _tmp0_;
	gint _tmp0__length1;
	g_return_if_fail (self != NULL);
	_tmp0_ = (value != NULL) ? _vala_array_dup16 (value, value_length1) : value;
	_tmp0__length1 = value_length1;
	self->priv->_problem_expression_prog = (_vala_PebblesProgrammerCalculatorToken_array_free (self->priv->_problem_expression_prog, self->priv->_problem_expression_prog_length1), NULL);
	self->priv->_problem_expression_prog = _tmp0_;
	self->priv->_problem_expression_prog_length1 = _tmp0__length1;
	self->priv->__problem_expression_prog_size_ = self->priv->_problem_expression_prog_length1;
}

gboolean*
pebbles_evaluation_result_get_prog_output (PebblesEvaluationResult* self,
                                           gint* result_length1)
{
	gboolean* result;
	gboolean* _tmp0_;
	gint _tmp0__length1;
	gboolean* _tmp1_;
	gint _tmp1__length1;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_prog_output;
	_tmp0__length1 = self->priv->_prog_output_length1;
	_tmp1_ = _tmp0_;
	_tmp1__length1 = _tmp0__length1;
	if (result_length1) {
		*result_length1 = _tmp1__length1;
	}
	result = _tmp1_;
	return result;
}

static gboolean*
_vala_array_dup17 (gboolean* self,
                   gssize length)
{
	if (length > 0) {
		return _vala_memdup2 (self, length * sizeof (gboolean));
	}
	return NULL;
}

void
pebbles_evaluation_result_set_prog_output (PebblesEvaluationResult* self,
                                           gboolean* value,
                                           gint value_length1)
{
	gboolean* _tmp0_;
	gint _tmp0__length1;
	g_return_if_fail (self != NULL);
	_tmp0_ = (value != NULL) ? _vala_array_dup17 (value, value_length1) : value;
	_tmp0__length1 = value_length1;
	self->priv->_prog_output = (g_free (self->priv->_prog_output), NULL);
	self->priv->_prog_output = _tmp0_;
	self->priv->_prog_output_length1 = _tmp0__length1;
	self->priv->__prog_output_size_ = self->priv->_prog_output_length1;
}

PebblesGlobalWordLength
pebbles_evaluation_result_get_word_length (PebblesEvaluationResult* self)
{
	PebblesGlobalWordLength result;
	PebblesGlobalWordLength _tmp0_;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->_word_length;
	result = _tmp0_;
	return result;
}

void
pebbles_evaluation_result_set_word_length (PebblesEvaluationResult* self,
                                           PebblesGlobalWordLength value)
{
	g_return_if_fail (self != NULL);
	self->priv->_word_length = value;
}

PebblesNumberSystem
pebbles_evaluation_result_get_number_system (PebblesEvaluationResult* self)
{
	PebblesNumberSystem result;
	PebblesNumberSystem _tmp0_;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->_number_system;
	result = _tmp0_;
	return result;
}

void
pebbles_evaluation_result_set_number_system (PebblesEvaluationResult* self,
                                             PebblesNumberSystem value)
{
	g_return_if_fail (self != NULL);
	self->priv->_number_system = value;
}

static void
pebbles_value_evaluation_result_init (GValue* value)
{
	value->data[0].v_pointer = NULL;
}

static void
pebbles_value_evaluation_result_free_value (GValue* value)
{
	if (value->data[0].v_pointer) {
		pebbles_evaluation_result_unref (value->data[0].v_pointer);
	}
}

static void
pebbles_value_evaluation_result_copy_value (const GValue* src_value,
                                            GValue* dest_value)
{
	if (src_value->data[0].v_pointer) {
		dest_value->data[0].v_pointer = pebbles_evaluation_result_ref (src_value->data[0].v_pointer);
	} else {
		dest_value->data[0].v_pointer = NULL;
	}
}

static gpointer
pebbles_value_evaluation_result_peek_pointer (const GValue* value)
{
	return value->data[0].v_pointer;
}

static gchar*
pebbles_value_evaluation_result_collect_value (GValue* value,
                                               guint n_collect_values,
                                               GTypeCValue* collect_values,
                                               guint collect_flags)
{
	if (collect_values[0].v_pointer) {
		PebblesEvaluationResult * object;
		object = collect_values[0].v_pointer;
		if (object->parent_instance.g_class == NULL) {
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		}
		value->data[0].v_pointer = pebbles_evaluation_result_ref (object);
	} else {
		value->data[0].v_pointer = NULL;
	}
	return NULL;
}

static gchar*
pebbles_value_evaluation_result_lcopy_value (const GValue* value,
                                             guint n_collect_values,
                                             GTypeCValue* collect_values,
                                             guint collect_flags)
{
	PebblesEvaluationResult ** object_p;
	object_p = collect_values[0].v_pointer;
	if (!object_p) {
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
	}
	if (!value->data[0].v_pointer) {
		*object_p = NULL;
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
		*object_p = value->data[0].v_pointer;
	} else {
		*object_p = pebbles_evaluation_result_ref (value->data[0].v_pointer);
	}
	return NULL;
}

GParamSpec*
pebbles_param_spec_evaluation_result (const gchar* name,
                                      const gchar* nick,
                                      const gchar* blurb,
                                      GType object_type,
                                      GParamFlags flags)
{
	PebblesParamSpecEvaluationResult* spec;
	g_return_val_if_fail (g_type_is_a (object_type, PEBBLES_TYPE_EVALUATION_RESULT), NULL);
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
	G_PARAM_SPEC (spec)->value_type = object_type;
	return G_PARAM_SPEC (spec);
}

gpointer
pebbles_value_get_evaluation_result (const GValue* value)
{
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, PEBBLES_TYPE_EVALUATION_RESULT), NULL);
	return value->data[0].v_pointer;
}

void
pebbles_value_set_evaluation_result (GValue* value,
                                     gpointer v_object)
{
	PebblesEvaluationResult * old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, PEBBLES_TYPE_EVALUATION_RESULT));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, PEBBLES_TYPE_EVALUATION_RESULT));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
		pebbles_evaluation_result_ref (value->data[0].v_pointer);
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		pebbles_evaluation_result_unref (old);
	}
}

void
pebbles_value_take_evaluation_result (GValue* value,
                                      gpointer v_object)
{
	PebblesEvaluationResult * old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, PEBBLES_TYPE_EVALUATION_RESULT));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, PEBBLES_TYPE_EVALUATION_RESULT));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		pebbles_evaluation_result_unref (old);
	}
}

static void
pebbles_evaluation_result_class_init (PebblesEvaluationResultClass * klass,
                                      gpointer klass_data)
{
	pebbles_evaluation_result_parent_class = g_type_class_peek_parent (klass);
	((PebblesEvaluationResultClass *) klass)->finalize = pebbles_evaluation_result_finalize;
	g_type_class_adjust_private_offset (klass, &PebblesEvaluationResult_private_offset);
}

static void
pebbles_evaluation_result_instance_init (PebblesEvaluationResult * self,
                                         gpointer klass)
{
	self->priv = pebbles_evaluation_result_get_instance_private (self);
	self->ref_count = 1;
}

static void
pebbles_evaluation_result_finalize (PebblesEvaluationResult * obj)
{
	PebblesEvaluationResult * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, PEBBLES_TYPE_EVALUATION_RESULT, PebblesEvaluationResult);
	g_signal_handlers_destroy (self);
	_g_free0 (self->priv->_problem_expression);
	_g_free0 (self->priv->_result);
	self->priv->_problem_expression_prog = (_vala_PebblesProgrammerCalculatorToken_array_free (self->priv->_problem_expression_prog, self->priv->_problem_expression_prog_length1), NULL);
	self->priv->_prog_output = (g_free (self->priv->_prog_output), NULL);
}

static GType
pebbles_evaluation_result_get_type_once (void)
{
	static const GTypeValueTable g_define_type_value_table = { pebbles_value_evaluation_result_init, pebbles_value_evaluation_result_free_value, pebbles_value_evaluation_result_copy_value, pebbles_value_evaluation_result_peek_pointer, "p", pebbles_value_evaluation_result_collect_value, "p", pebbles_value_evaluation_result_lcopy_value };
	static const GTypeInfo g_define_type_info = { sizeof (PebblesEvaluationResultClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) pebbles_evaluation_result_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PebblesEvaluationResult), 0, (GInstanceInitFunc) pebbles_evaluation_result_instance_init, &g_define_type_value_table };
	static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
	GType pebbles_evaluation_result_type_id;
	pebbles_evaluation_result_type_id = g_type_register_fundamental (g_type_fundamental_next (), "PebblesEvaluationResult", &g_define_type_info, &g_define_type_fundamental_info, 0);
	PebblesEvaluationResult_private_offset = g_type_add_instance_private (pebbles_evaluation_result_type_id, sizeof (PebblesEvaluationResultPrivate));
	return pebbles_evaluation_result_type_id;
}

GType
pebbles_evaluation_result_get_type (void)
{
	static volatile gsize pebbles_evaluation_result_type_id__volatile = 0;
	if (g_once_init_enter (&pebbles_evaluation_result_type_id__volatile)) {
		GType pebbles_evaluation_result_type_id;
		pebbles_evaluation_result_type_id = pebbles_evaluation_result_get_type_once ();
		g_once_init_leave (&pebbles_evaluation_result_type_id__volatile, pebbles_evaluation_result_type_id);
	}
	return pebbles_evaluation_result_type_id__volatile;
}

gpointer
pebbles_evaluation_result_ref (gpointer instance)
{
	PebblesEvaluationResult * self;
	self = instance;
	g_atomic_int_inc (&self->ref_count);
	return instance;
}

void
pebbles_evaluation_result_unref (gpointer instance)
{
	PebblesEvaluationResult * self;
	self = instance;
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
		PEBBLES_EVALUATION_RESULT_GET_CLASS (self)->finalize (self);
		g_type_free_instance ((GTypeInstance *) self);
	}
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

