/* Programmer.c generated by valac 0.53.2, the Vala compiler
 * generated from Programmer.vala, do not modify */

/*-
 * Copyright (c) 2017-2020 Subhadeep Jasu <subhajasu@gmail.com>
 * Copyright (c) 2017-2020 Saunak Biswas <saunakbis97@gmail.com>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation; either
 * version 3 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License 
 * along with this program. If not, see <https://www.gnu.org/licenses/>.
 *
 * Authored by: Subhadeep Jasu <subhajasu@gmail.com>
 *              Saunak Biswas  <saunakbis97@gmail.com>
 */

#include <glib-object.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <gobject/gvaluecollector.h>

#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

typedef enum  {
	PEBBLES_WORD_SIZE_BYTE = 8,
	PEBBLES_WORD_SIZE_WORD = 16,
	PEBBLES_WORD_SIZE_DWORD = 32,
	PEBBLES_WORD_SIZE_QWORD = 64
} PebblesWordSize;

#define PEBBLES_TYPE_WORD_SIZE (pebbles_word_size_get_type ())

#define PEBBLES_TYPE_PROGRAMMER (pebbles_programmer_get_type ())
#define PEBBLES_PROGRAMMER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), PEBBLES_TYPE_PROGRAMMER, PebblesProgrammer))
#define PEBBLES_PROGRAMMER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), PEBBLES_TYPE_PROGRAMMER, PebblesProgrammerClass))
#define PEBBLES_IS_PROGRAMMER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), PEBBLES_TYPE_PROGRAMMER))
#define PEBBLES_IS_PROGRAMMER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), PEBBLES_TYPE_PROGRAMMER))
#define PEBBLES_PROGRAMMER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), PEBBLES_TYPE_PROGRAMMER, PebblesProgrammerClass))

typedef struct _PebblesProgrammer PebblesProgrammer;
typedef struct _PebblesProgrammerClass PebblesProgrammerClass;
typedef struct _PebblesProgrammerPrivate PebblesProgrammerPrivate;
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _PebblesParamSpecProgrammer PebblesParamSpecProgrammer;

typedef enum  {
	PEBBLES_CALC_ERROR_DIVIDE_BY_ZERO
} PebblesCalcError;
#define PEBBLES_CALC_ERROR pebbles_calc_error_quark ()
struct _PebblesProgrammer {
	GTypeInstance parent_instance;
	volatile int ref_count;
	PebblesProgrammerPrivate * priv;
	PebblesWordSize word_size;
	gboolean* output;
	gint output_length1;
	gboolean carry;
	gboolean aux_carry;
	gboolean f0;
	gboolean overflow_flag;
	gboolean parity_flag;
	gboolean zero_flag;
	gboolean negative_flag;
};

struct _PebblesProgrammerClass {
	GTypeClass parent_class;
	void (*finalize) (PebblesProgrammer *self);
};

struct _PebblesParamSpecProgrammer {
	GParamSpec parent_instance;
};

static gpointer pebbles_programmer_parent_class = NULL;

VALA_EXTERN GType pebbles_word_size_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GQuark pebbles_calc_error_quark (void);
VALA_EXTERN gpointer pebbles_programmer_ref (gpointer instance);
VALA_EXTERN void pebbles_programmer_unref (gpointer instance);
VALA_EXTERN GParamSpec* pebbles_param_spec_programmer (const gchar* name,
                                           const gchar* nick,
                                           const gchar* blurb,
                                           GType object_type,
                                           GParamFlags flags);
VALA_EXTERN void pebbles_value_set_programmer (GValue* value,
                                   gpointer v_object);
VALA_EXTERN void pebbles_value_take_programmer (GValue* value,
                                    gpointer v_object);
VALA_EXTERN gpointer pebbles_value_get_programmer (const GValue* value);
VALA_EXTERN GType pebbles_programmer_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (PebblesProgrammer, pebbles_programmer_unref)
VALA_EXTERN PebblesProgrammer* pebbles_programmer_new (void);
VALA_EXTERN PebblesProgrammer* pebbles_programmer_construct (GType object_type);
VALA_EXTERN gboolean pebbles_programmer_xor_each_bit (PebblesProgrammer* self,
                                          gboolean a,
                                          gboolean b);
VALA_EXTERN gboolean pebbles_programmer_full_add (PebblesProgrammer* self,
                                      gboolean a,
                                      gboolean b);
VALA_EXTERN gboolean* pebbles_programmer_add (PebblesProgrammer* self,
                                  gboolean* input_a,
                                  gint input_a_length1,
                                  gboolean* input_b,
                                  gint input_b_length1,
                                  gint* word_size,
                                  gint* result_length1);
static gboolean* _vala_array_dup20 (gboolean* self,
                             gssize length);
VALA_EXTERN gboolean* pebbles_programmer_ones_complement (PebblesProgrammer* self,
                                              gboolean* input,
                                              gint input_length1,
                                              gint* word_size,
                                              gint* result_length1);
static gboolean* _vala_array_dup21 (gboolean* self,
                             gssize length);
VALA_EXTERN gboolean* pebbles_programmer_twos_complement (PebblesProgrammer* self,
                                              gboolean* input,
                                              gint input_length1,
                                              gint* word_size,
                                              gint* result_length1);
static gboolean* _vala_array_dup22 (gboolean* self,
                             gssize length);
VALA_EXTERN gboolean* pebbles_programmer_subtract (PebblesProgrammer* self,
                                       gboolean* input_a,
                                       gint input_a_length1,
                                       gboolean* input_b,
                                       gint input_b_length1,
                                       gint* word_size,
                                       gint* result_length1);
static gboolean* _vala_array_dup23 (gboolean* self,
                             gssize length);
VALA_EXTERN gboolean pebbles_programmer_multiply_two_bits (PebblesProgrammer* self,
                                               gboolean a,
                                               gboolean b);
VALA_EXTERN gchar* pebbles_programmer_multiply (PebblesProgrammer* self,
                                    gboolean* input_a,
                                    gint input_a_length1,
                                    gboolean* input_b,
                                    gint input_b_length1,
                                    gint* word_size);
VALA_EXTERN gchar* pebbles_programmer_division_signed_integer (PebblesProgrammer* self,
                                                   gboolean* input_a,
                                                   gint input_a_length1,
                                                   gboolean* input_b,
                                                   gint input_b_length1,
                                                   gint* word_size);
VALA_EXTERN gchar* pebbles_programmer_mod_signed_integer (PebblesProgrammer* self,
                                              gboolean* input_a,
                                              gint input_a_length1,
                                              gboolean* input_b,
                                              gint input_b_length1,
                                              gint* word_size);
VALA_EXTERN gboolean* pebbles_programmer_division_quotient (PebblesProgrammer* self,
                                                gboolean* input_a,
                                                gint input_a_length1,
                                                gboolean* input_b,
                                                gint input_b_length1,
                                                gint* word_size,
                                                gint* result_length1);
static gint pebbles_programmer_find_right_most_one (PebblesProgrammer* self,
                                             gboolean* input,
                                             gint input_length1);
VALA_EXTERN gboolean* pebbles_programmer_left_shift (PebblesProgrammer* self,
                                         gboolean* input_a,
                                         gint input_a_length1,
                                         gboolean* input_b,
                                         gint input_b_length1,
                                         gboolean fill_bits,
                                         gint* word_size,
                                         gint* result_length1);
VALA_EXTERN gint pebbles_programmer_comparator (PebblesProgrammer* self,
                                    gboolean* input_a,
                                    gint input_a_length1,
                                    gboolean* input_b,
                                    gint input_b_length1,
                                    gint* word_size);
static gboolean* _vala_array_dup24 (gboolean* self,
                             gssize length);
static gboolean* _vala_array_dup25 (gboolean* self,
                             gssize length);
VALA_EXTERN gboolean* pebbles_programmer_right_shift (PebblesProgrammer* self,
                                          gboolean* input_a,
                                          gint input_a_length1,
                                          gboolean* input_b,
                                          gint input_b_length1,
                                          gboolean fill_bits,
                                          gint* word_size,
                                          gint* result_length1);
static gboolean* _vala_array_dup26 (gboolean* self,
                             gssize length);
VALA_EXTERN gboolean* pebbles_programmer_and (PebblesProgrammer* self,
                                  gboolean* input_a,
                                  gint input_a_length1,
                                  gboolean* input_b,
                                  gint input_b_length1,
                                  gint* word_size,
                                  gint* result_length1);
static gboolean* _vala_array_dup27 (gboolean* self,
                             gssize length);
VALA_EXTERN gboolean* pebbles_programmer_nand (PebblesProgrammer* self,
                                   gboolean* input_a,
                                   gint input_a_length1,
                                   gboolean* input_b,
                                   gint input_b_length1,
                                   gint* word_size,
                                   gint* result_length1);
static gboolean* _vala_array_dup28 (gboolean* self,
                             gssize length);
VALA_EXTERN gboolean* pebbles_programmer_or (PebblesProgrammer* self,
                                 gboolean* input_a,
                                 gint input_a_length1,
                                 gboolean* input_b,
                                 gint input_b_length1,
                                 gint* word_size,
                                 gint* result_length1);
static gboolean* _vala_array_dup29 (gboolean* self,
                             gssize length);
VALA_EXTERN gboolean* pebbles_programmer_nor (PebblesProgrammer* self,
                                  gboolean* input_a,
                                  gint input_a_length1,
                                  gboolean* input_b,
                                  gint input_b_length1,
                                  gint* word_size,
                                  gint* result_length1);
static gboolean* _vala_array_dup30 (gboolean* self,
                             gssize length);
VALA_EXTERN gboolean* pebbles_programmer_xor (PebblesProgrammer* self,
                                  gboolean* input_a,
                                  gint input_a_length1,
                                  gboolean* input_b,
                                  gint input_b_length1,
                                  gint* word_size,
                                  gint* result_length1);
static gboolean* _vala_array_dup31 (gboolean* self,
                             gssize length);
VALA_EXTERN gboolean* pebbles_programmer_xnor (PebblesProgrammer* self,
                                   gboolean* input_a,
                                   gint input_a_length1,
                                   gboolean* input_b,
                                   gint input_b_length1,
                                   gint* word_size,
                                   gint* result_length1);
static gboolean* _vala_array_dup32 (gboolean* self,
                             gssize length);
VALA_EXTERN gboolean* pebbles_programmer_not (PebblesProgrammer* self,
                                  gboolean* input,
                                  gint input_length1,
                                  gint* word_size,
                                  gint* result_length1);
static gboolean* _vala_array_dup33 (gboolean* self,
                             gssize length);
static void pebbles_programmer_finalize (PebblesProgrammer * obj);
static GType pebbles_programmer_get_type_once (void);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

static GType
pebbles_word_size_get_type_once (void)
{
	static const GEnumValue values[] = {{PEBBLES_WORD_SIZE_BYTE, "PEBBLES_WORD_SIZE_BYTE", "byte"}, {PEBBLES_WORD_SIZE_WORD, "PEBBLES_WORD_SIZE_WORD", "word"}, {PEBBLES_WORD_SIZE_DWORD, "PEBBLES_WORD_SIZE_DWORD", "dword"}, {PEBBLES_WORD_SIZE_QWORD, "PEBBLES_WORD_SIZE_QWORD", "qword"}, {0, NULL, NULL}};
	GType pebbles_word_size_type_id;
	pebbles_word_size_type_id = g_enum_register_static ("PebblesWordSize", values);
	return pebbles_word_size_type_id;
}

GType
pebbles_word_size_get_type (void)
{
	static volatile gsize pebbles_word_size_type_id__volatile = 0;
	if (g_once_init_enter (&pebbles_word_size_type_id__volatile)) {
		GType pebbles_word_size_type_id;
		pebbles_word_size_type_id = pebbles_word_size_get_type_once ();
		g_once_init_leave (&pebbles_word_size_type_id__volatile, pebbles_word_size_type_id);
	}
	return pebbles_word_size_type_id__volatile;
}

GQuark
pebbles_calc_error_quark (void)
{
	return g_quark_from_static_string ("pebbles-calc-error-quark");
}

PebblesProgrammer*
pebbles_programmer_construct (GType object_type)
{
	PebblesProgrammer* self = NULL;
	gboolean* _tmp0_;
	self = (PebblesProgrammer*) g_type_create_instance (object_type);
	_tmp0_ = g_new0 (gboolean, 64);
	self->output = (g_free (self->output), NULL);
	self->output = _tmp0_;
	self->output_length1 = 64;
	return self;
}

PebblesProgrammer*
pebbles_programmer_new (void)
{
	return pebbles_programmer_construct (PEBBLES_TYPE_PROGRAMMER);
}

gboolean
pebbles_programmer_xor_each_bit (PebblesProgrammer* self,
                                 gboolean a,
                                 gboolean b)
{
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	if (a == b) {
		result = FALSE;
		return result;
	}
	result = TRUE;
	return result;
}

gboolean
pebbles_programmer_full_add (PebblesProgrammer* self,
                             gboolean a,
                             gboolean b)
{
	gboolean c = FALSE;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	c = self->carry;
	if (a) {
		_tmp2_ = b;
	} else {
		_tmp2_ = FALSE;
	}
	if (_tmp2_) {
		_tmp1_ = TRUE;
	} else {
		gboolean _tmp3_ = FALSE;
		if (b) {
			_tmp3_ = self->carry;
		} else {
			_tmp3_ = FALSE;
		}
		_tmp1_ = _tmp3_;
	}
	if (_tmp1_) {
		_tmp0_ = TRUE;
	} else {
		gboolean _tmp4_ = FALSE;
		if (a) {
			_tmp4_ = self->carry;
		} else {
			_tmp4_ = FALSE;
		}
		_tmp0_ = _tmp4_;
	}
	self->carry = _tmp0_;
	result = pebbles_programmer_xor_each_bit (self, c, pebbles_programmer_xor_each_bit (self, a, b));
	return result;
}

static gboolean*
_vala_array_dup20 (gboolean* self,
                   gssize length)
{
	if (length > 0) {
		return _vala_memdup2 (self, length * sizeof (gboolean));
	}
	return NULL;
}

gboolean*
pebbles_programmer_add (PebblesProgrammer* self,
                        gboolean* input_a,
                        gint input_a_length1,
                        gboolean* input_b,
                        gint input_b_length1,
                        gint* word_size,
                        gint* result_length1)
{
	gboolean* _tmp5_;
	gint _tmp5__length1;
	gboolean* _tmp6_;
	gint _tmp6__length1;
	gboolean* _tmp7_;
	gint _tmp7__length1;
	gboolean* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	{
		gint i = 0;
		i = 63;
		{
			gboolean _tmp0_ = FALSE;
			_tmp0_ = TRUE;
			while (TRUE) {
				gboolean* _tmp2_;
				gint _tmp2__length1;
				gboolean _tmp3_;
				gboolean _tmp4_;
				if (!_tmp0_) {
					gint _tmp1_;
					_tmp1_ = i;
					i = _tmp1_ - 1;
				}
				_tmp0_ = FALSE;
				if (!(i > (63 - (*word_size)))) {
					break;
				}
				_tmp2_ = self->output;
				_tmp2__length1 = self->output_length1;
				_tmp3_ = input_a[i];
				_tmp4_ = input_b[i];
				_tmp2_[i] = pebbles_programmer_full_add (self, _tmp3_, _tmp4_);
			}
		}
	}
	_tmp5_ = self->output;
	_tmp5__length1 = self->output_length1;
	_tmp6_ = (_tmp5_ != NULL) ? _vala_array_dup20 (_tmp5_, _tmp5__length1) : _tmp5_;
	_tmp6__length1 = _tmp5__length1;
	_tmp7_ = _tmp6_;
	_tmp7__length1 = _tmp6__length1;
	if (result_length1) {
		*result_length1 = _tmp7__length1;
	}
	result = _tmp7_;
	return result;
}

static gboolean*
_vala_array_dup21 (gboolean* self,
                   gssize length)
{
	if (length > 0) {
		return _vala_memdup2 (self, length * sizeof (gboolean));
	}
	return NULL;
}

gboolean*
pebbles_programmer_ones_complement (PebblesProgrammer* self,
                                    gboolean* input,
                                    gint input_length1,
                                    gint* word_size,
                                    gint* result_length1)
{
	gboolean* _tmp4_;
	gint _tmp4__length1;
	gboolean* _tmp5_;
	gint _tmp5__length1;
	gboolean* _tmp6_;
	gint _tmp6__length1;
	gboolean* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	{
		gint i = 0;
		i = 64 - (*word_size);
		{
			gboolean _tmp0_ = FALSE;
			_tmp0_ = TRUE;
			while (TRUE) {
				gboolean* _tmp2_;
				gint _tmp2__length1;
				gboolean _tmp3_;
				if (!_tmp0_) {
					gint _tmp1_;
					_tmp1_ = i;
					i = _tmp1_ + 1;
				}
				_tmp0_ = FALSE;
				if (!(i < 64)) {
					break;
				}
				_tmp2_ = self->output;
				_tmp2__length1 = self->output_length1;
				_tmp3_ = input[i];
				_tmp2_[i] = !_tmp3_;
			}
		}
	}
	_tmp4_ = self->output;
	_tmp4__length1 = self->output_length1;
	_tmp5_ = (_tmp4_ != NULL) ? _vala_array_dup21 (_tmp4_, _tmp4__length1) : _tmp4_;
	_tmp5__length1 = _tmp4__length1;
	_tmp6_ = _tmp5_;
	_tmp6__length1 = _tmp5__length1;
	if (result_length1) {
		*result_length1 = _tmp6__length1;
	}
	result = _tmp6_;
	return result;
}

static gboolean*
_vala_array_dup22 (gboolean* self,
                   gssize length)
{
	if (length > 0) {
		return _vala_memdup2 (self, length * sizeof (gboolean));
	}
	return NULL;
}

gboolean*
pebbles_programmer_twos_complement (PebblesProgrammer* self,
                                    gboolean* input,
                                    gint input_length1,
                                    gint* word_size,
                                    gint* result_length1)
{
	gboolean* input_copy = NULL;
	gint _tmp0_ = 0;
	gboolean* _tmp1_;
	gint input_copy_length1;
	gint _input_copy_size_;
	gboolean* binary_one = NULL;
	gboolean* _tmp2_;
	gint binary_one_length1;
	gint _binary_one_size_;
	gint _tmp3_ = 0;
	gboolean* _tmp4_;
	gboolean* _tmp5_;
	gint _tmp5__length1;
	gboolean* _tmp6_;
	gint _tmp6__length1;
	gboolean* _tmp7_;
	gint _tmp7__length1;
	gboolean* _tmp8_;
	gint _tmp8__length1;
	gboolean* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp1_ = pebbles_programmer_ones_complement (self, input, (gint) input_length1, word_size, &_tmp0_);
	input_copy = _tmp1_;
	input_copy_length1 = _tmp0_;
	_input_copy_size_ = input_copy_length1;
	_tmp2_ = g_new0 (gboolean, 64);
	binary_one = _tmp2_;
	binary_one_length1 = 64;
	_binary_one_size_ = binary_one_length1;
	binary_one[63] = TRUE;
	_tmp4_ = pebbles_programmer_add (self, input_copy, (gint) input_copy_length1, binary_one, (gint) binary_one_length1, word_size, &_tmp3_);
	_tmp5_ = _tmp4_;
	_tmp5__length1 = _tmp3_;
	_tmp5_ = (g_free (_tmp5_), NULL);
	_tmp6_ = self->output;
	_tmp6__length1 = self->output_length1;
	_tmp7_ = (_tmp6_ != NULL) ? _vala_array_dup22 (_tmp6_, _tmp6__length1) : _tmp6_;
	_tmp7__length1 = _tmp6__length1;
	_tmp8_ = _tmp7_;
	_tmp8__length1 = _tmp7__length1;
	if (result_length1) {
		*result_length1 = _tmp8__length1;
	}
	result = _tmp8_;
	binary_one = (g_free (binary_one), NULL);
	input_copy = (g_free (input_copy), NULL);
	return result;
}

static gboolean*
_vala_array_dup23 (gboolean* self,
                   gssize length)
{
	if (length > 0) {
		return _vala_memdup2 (self, length * sizeof (gboolean));
	}
	return NULL;
}

gboolean*
pebbles_programmer_subtract (PebblesProgrammer* self,
                             gboolean* input_a,
                             gint input_a_length1,
                             gboolean* input_b,
                             gint input_b_length1,
                             gint* word_size,
                             gint* result_length1)
{
	gboolean* input_b_copy = NULL;
	gint _tmp0_ = 0;
	gboolean* _tmp1_;
	gint input_b_copy_length1;
	gint _input_b_copy_size_;
	gint _tmp2_ = 0;
	gboolean* _tmp3_;
	gboolean* _tmp4_;
	gint _tmp4__length1;
	gboolean* _tmp5_;
	gint _tmp5__length1;
	gboolean* _tmp6_;
	gint _tmp6__length1;
	gboolean* _tmp7_;
	gint _tmp7__length1;
	gboolean* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp1_ = pebbles_programmer_twos_complement (self, input_b, (gint) input_b_length1, word_size, &_tmp0_);
	input_b_copy = _tmp1_;
	input_b_copy_length1 = _tmp0_;
	_input_b_copy_size_ = input_b_copy_length1;
	_tmp3_ = pebbles_programmer_add (self, input_a, (gint) input_a_length1, input_b_copy, (gint) input_b_copy_length1, word_size, &_tmp2_);
	_tmp4_ = _tmp3_;
	_tmp4__length1 = _tmp2_;
	_tmp4_ = (g_free (_tmp4_), NULL);
	_tmp5_ = self->output;
	_tmp5__length1 = self->output_length1;
	_tmp6_ = (_tmp5_ != NULL) ? _vala_array_dup23 (_tmp5_, _tmp5__length1) : _tmp5_;
	_tmp6__length1 = _tmp5__length1;
	_tmp7_ = _tmp6_;
	_tmp7__length1 = _tmp6__length1;
	if (result_length1) {
		*result_length1 = _tmp7__length1;
	}
	result = _tmp7_;
	input_b_copy = (g_free (input_b_copy), NULL);
	return result;
}

gboolean
pebbles_programmer_multiply_two_bits (PebblesProgrammer* self,
                                      gboolean a,
                                      gboolean b)
{
	gboolean _tmp0_ = FALSE;
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	if (a == TRUE) {
		_tmp0_ = b == TRUE;
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		result = TRUE;
		return result;
	}
	result = FALSE;
	return result;
}

gchar*
pebbles_programmer_multiply (PebblesProgrammer* self,
                             gboolean* input_a,
                             gint input_a_length1,
                             gboolean* input_b,
                             gint input_b_length1,
                             gint* word_size)
{
	gchar* input_a_s = NULL;
	gchar* _tmp0_;
	gchar* input_b_s = NULL;
	gchar* _tmp1_;
	gint64 int_dividend = 0LL;
	const gchar* _tmp12_;
	gint64 _tmp13_ = 0LL;
	gint64 int_divisor = 0LL;
	const gchar* _tmp14_;
	gint64 _tmp15_ = 0LL;
	gint64 product = 0LL;
	gchar* _tmp16_;
	GError* _inner_error0_ = NULL;
	gchar* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = g_strdup ("");
	input_a_s = _tmp0_;
	_tmp1_ = g_strdup ("");
	input_b_s = _tmp1_;
	{
		gint i = 0;
		i = 63;
		{
			gboolean _tmp2_ = FALSE;
			_tmp2_ = TRUE;
			while (TRUE) {
				const gchar* _tmp4_ = NULL;
				gboolean _tmp5_;
				const gchar* _tmp6_;
				gchar* _tmp7_;
				const gchar* _tmp8_ = NULL;
				gboolean _tmp9_;
				const gchar* _tmp10_;
				gchar* _tmp11_;
				if (!_tmp2_) {
					gint _tmp3_;
					_tmp3_ = i;
					i = _tmp3_ - 1;
				}
				_tmp2_ = FALSE;
				if (!(i >= 0)) {
					break;
				}
				_tmp5_ = input_a[i];
				if (_tmp5_) {
					_tmp4_ = "1";
				} else {
					_tmp4_ = "0";
				}
				_tmp6_ = input_a_s;
				_tmp7_ = g_strconcat (_tmp4_, _tmp6_, NULL);
				_g_free0 (input_a_s);
				input_a_s = _tmp7_;
				_tmp9_ = input_b[i];
				if (_tmp9_) {
					_tmp8_ = "1";
				} else {
					_tmp8_ = "0";
				}
				_tmp10_ = input_b_s;
				_tmp11_ = g_strconcat (_tmp8_, _tmp10_, NULL);
				_g_free0 (input_b_s);
				input_b_s = _tmp11_;
			}
		}
	}
	_tmp12_ = input_a_s;
	g_ascii_string_to_signed (_tmp12_, (guint) 2, G_MININT64, G_MAXINT64, &_tmp13_, &_inner_error0_);
	int_dividend = _tmp13_;
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		_g_free0 (input_b_s);
		_g_free0 (input_a_s);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return NULL;
	}
	_tmp14_ = input_b_s;
	g_ascii_string_to_signed (_tmp14_, (guint) 2, G_MININT64, G_MAXINT64, &_tmp15_, &_inner_error0_);
	int_divisor = _tmp15_;
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		_g_free0 (input_b_s);
		_g_free0 (input_a_s);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return NULL;
	}
	product = int_dividend * int_divisor;
	_tmp16_ = g_strdup_printf ("%" G_GINT64_FORMAT, product);
	result = _tmp16_;
	_g_free0 (input_b_s);
	_g_free0 (input_a_s);
	return result;
}

gchar*
pebbles_programmer_division_signed_integer (PebblesProgrammer* self,
                                            gboolean* input_a,
                                            gint input_a_length1,
                                            gboolean* input_b,
                                            gint input_b_length1,
                                            gint* word_size)
{
	gchar* dividend = NULL;
	gchar* _tmp0_;
	gchar* divisor = NULL;
	gchar* _tmp1_;
	gint64 int_dividend = 0LL;
	const gchar* _tmp12_;
	gint64 _tmp13_ = 0LL;
	gint64 int_divisor = 0LL;
	const gchar* _tmp14_;
	gint64 _tmp15_ = 0LL;
	gint64 quotient = 0LL;
	gchar* _tmp17_;
	GError* _inner_error0_ = NULL;
	gchar* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = g_strdup ("");
	dividend = _tmp0_;
	_tmp1_ = g_strdup ("");
	divisor = _tmp1_;
	{
		gint i = 0;
		i = 63;
		{
			gboolean _tmp2_ = FALSE;
			_tmp2_ = TRUE;
			while (TRUE) {
				const gchar* _tmp4_ = NULL;
				gboolean _tmp5_;
				const gchar* _tmp6_;
				gchar* _tmp7_;
				const gchar* _tmp8_ = NULL;
				gboolean _tmp9_;
				const gchar* _tmp10_;
				gchar* _tmp11_;
				if (!_tmp2_) {
					gint _tmp3_;
					_tmp3_ = i;
					i = _tmp3_ - 1;
				}
				_tmp2_ = FALSE;
				if (!(i >= 0)) {
					break;
				}
				_tmp5_ = input_a[i];
				if (_tmp5_) {
					_tmp4_ = "1";
				} else {
					_tmp4_ = "0";
				}
				_tmp6_ = dividend;
				_tmp7_ = g_strconcat (_tmp4_, _tmp6_, NULL);
				_g_free0 (dividend);
				dividend = _tmp7_;
				_tmp9_ = input_b[i];
				if (_tmp9_) {
					_tmp8_ = "1";
				} else {
					_tmp8_ = "0";
				}
				_tmp10_ = divisor;
				_tmp11_ = g_strconcat (_tmp8_, _tmp10_, NULL);
				_g_free0 (divisor);
				divisor = _tmp11_;
			}
		}
	}
	_tmp12_ = dividend;
	g_ascii_string_to_signed (_tmp12_, (guint) 2, G_MININT64, G_MAXINT64, &_tmp13_, &_inner_error0_);
	int_dividend = _tmp13_;
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		_g_free0 (divisor);
		_g_free0 (dividend);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return NULL;
	}
	_tmp14_ = divisor;
	g_ascii_string_to_signed (_tmp14_, (guint) 2, G_MININT64, G_MAXINT64, &_tmp15_, &_inner_error0_);
	int_divisor = _tmp15_;
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		_g_free0 (divisor);
		_g_free0 (dividend);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return NULL;
	}
	if (int_divisor == ((gint64) 0)) {
		gchar* _tmp16_;
		_tmp16_ = g_strdup ("Error");
		result = _tmp16_;
		_g_free0 (divisor);
		_g_free0 (dividend);
		return result;
	}
	quotient = int_dividend / int_divisor;
	_tmp17_ = g_strdup_printf ("%" G_GINT64_FORMAT, quotient);
	result = _tmp17_;
	_g_free0 (divisor);
	_g_free0 (dividend);
	return result;
}

gchar*
pebbles_programmer_mod_signed_integer (PebblesProgrammer* self,
                                       gboolean* input_a,
                                       gint input_a_length1,
                                       gboolean* input_b,
                                       gint input_b_length1,
                                       gint* word_size)
{
	gchar* dividend = NULL;
	gchar* _tmp0_;
	gchar* divisor = NULL;
	gchar* _tmp1_;
	gint64 int_dividend = 0LL;
	const gchar* _tmp12_;
	gint64 _tmp13_ = 0LL;
	gint64 int_divisor = 0LL;
	const gchar* _tmp14_;
	gint64 _tmp15_ = 0LL;
	gint64 remainder = 0LL;
	gchar* _tmp17_;
	GError* _inner_error0_ = NULL;
	gchar* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = g_strdup ("");
	dividend = _tmp0_;
	_tmp1_ = g_strdup ("");
	divisor = _tmp1_;
	{
		gint i = 0;
		i = 63;
		{
			gboolean _tmp2_ = FALSE;
			_tmp2_ = TRUE;
			while (TRUE) {
				const gchar* _tmp4_ = NULL;
				gboolean _tmp5_;
				const gchar* _tmp6_;
				gchar* _tmp7_;
				const gchar* _tmp8_ = NULL;
				gboolean _tmp9_;
				const gchar* _tmp10_;
				gchar* _tmp11_;
				if (!_tmp2_) {
					gint _tmp3_;
					_tmp3_ = i;
					i = _tmp3_ - 1;
				}
				_tmp2_ = FALSE;
				if (!(i >= 0)) {
					break;
				}
				_tmp5_ = input_a[i];
				if (_tmp5_) {
					_tmp4_ = "1";
				} else {
					_tmp4_ = "0";
				}
				_tmp6_ = dividend;
				_tmp7_ = g_strconcat (_tmp4_, _tmp6_, NULL);
				_g_free0 (dividend);
				dividend = _tmp7_;
				_tmp9_ = input_b[i];
				if (_tmp9_) {
					_tmp8_ = "1";
				} else {
					_tmp8_ = "0";
				}
				_tmp10_ = divisor;
				_tmp11_ = g_strconcat (_tmp8_, _tmp10_, NULL);
				_g_free0 (divisor);
				divisor = _tmp11_;
			}
		}
	}
	_tmp12_ = dividend;
	g_ascii_string_to_signed (_tmp12_, (guint) 2, G_MININT64, G_MAXINT64, &_tmp13_, &_inner_error0_);
	int_dividend = _tmp13_;
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		_g_free0 (divisor);
		_g_free0 (dividend);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return NULL;
	}
	_tmp14_ = divisor;
	g_ascii_string_to_signed (_tmp14_, (guint) 2, G_MININT64, G_MAXINT64, &_tmp15_, &_inner_error0_);
	int_divisor = _tmp15_;
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		_g_free0 (divisor);
		_g_free0 (dividend);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return NULL;
	}
	if (int_divisor == ((gint64) 0)) {
		gchar* _tmp16_;
		_tmp16_ = g_strdup ("Error");
		result = _tmp16_;
		_g_free0 (divisor);
		_g_free0 (dividend);
		return result;
	}
	remainder = int_dividend % int_divisor;
	_tmp17_ = g_strdup_printf ("%" G_GINT64_FORMAT, remainder);
	result = _tmp17_;
	_g_free0 (divisor);
	_g_free0 (dividend);
	return result;
}

static gboolean*
_vala_array_dup24 (gboolean* self,
                   gssize length)
{
	if (length > 0) {
		return _vala_memdup2 (self, length * sizeof (gboolean));
	}
	return NULL;
}

gboolean*
pebbles_programmer_division_quotient (PebblesProgrammer* self,
                                      gboolean* input_a,
                                      gint input_a_length1,
                                      gboolean* input_b,
                                      gint input_b_length1,
                                      gint* word_size,
                                      gint* result_length1)
{
	gboolean* dividend = NULL;
	gboolean* _tmp0_;
	gint dividend_length1;
	gint _dividend_size_;
	gint comparator_result = 0;
	gboolean* shift_size = NULL;
	gboolean* _tmp5_;
	gint shift_size_length1;
	gint _shift_size_size_;
	gboolean* _tmp6_;
	gint _tmp6__length1;
	gboolean* _tmp7_;
	gint right_most = 0;
	gboolean* _tmp24_;
	gint _tmp24__length1;
	gboolean* _tmp25_;
	gint _tmp25__length1;
	gboolean* _tmp26_;
	gint _tmp26__length1;
	gboolean* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = g_new0 (gboolean, 64);
	dividend = _tmp0_;
	dividend_length1 = 64;
	_dividend_size_ = dividend_length1;
	{
		gint i = 0;
		i = 63;
		{
			gboolean _tmp1_ = FALSE;
			_tmp1_ = TRUE;
			while (TRUE) {
				gboolean* _tmp3_;
				gint _tmp3__length1;
				gboolean _tmp4_;
				if (!_tmp1_) {
					gint _tmp2_;
					_tmp2_ = i;
					i = _tmp2_ - 1;
				}
				_tmp1_ = FALSE;
				if (!(i >= (64 - input_a_length1))) {
					break;
				}
				_tmp3_ = dividend;
				_tmp3__length1 = dividend_length1;
				_tmp4_ = input_a[i];
				_tmp3_[i] = _tmp4_;
			}
		}
	}
	_tmp5_ = g_new0 (gboolean, 64);
	shift_size = _tmp5_;
	shift_size_length1 = 64;
	_shift_size_size_ = shift_size_length1;
	_tmp6_ = shift_size;
	_tmp6__length1 = shift_size_length1;
	_tmp6_[63] = TRUE;
	_tmp7_ = g_new0 (gboolean, 64);
	self->output = (g_free (self->output), NULL);
	self->output = _tmp7_;
	self->output_length1 = 64;
	right_most = pebbles_programmer_find_right_most_one (self, input_a, (gint) input_a_length1);
	{
		gint i = 0;
		i = (64 - ((gint) (*word_size))) + right_most;
		{
			gboolean _tmp8_ = FALSE;
			_tmp8_ = TRUE;
			while (TRUE) {
				gboolean* _tmp10_;
				gint _tmp10__length1;
				gboolean* _tmp11_;
				gint _tmp11__length1;
				gboolean* _tmp12_;
				gint _tmp12__length1;
				gboolean _tmp13_;
				gint _tmp14_ = 0;
				gboolean* _tmp15_;
				gboolean* _tmp16_;
				gint _tmp16__length1;
				gboolean _tmp17_;
				gboolean* _tmp18_;
				gint _tmp18__length1;
				if (!_tmp8_) {
					gint _tmp9_;
					_tmp9_ = i;
					i = _tmp9_ + 1;
				}
				_tmp8_ = FALSE;
				if (!(i < 64)) {
					break;
				}
				_tmp10_ = dividend;
				_tmp10__length1 = dividend_length1;
				_tmp11_ = shift_size;
				_tmp11__length1 = shift_size_length1;
				_tmp12_ = dividend;
				_tmp12__length1 = dividend_length1;
				_tmp13_ = _tmp12_[64 - (*word_size)];
				_tmp15_ = pebbles_programmer_left_shift (self, _tmp10_, (gint) _tmp10__length1, _tmp11_, (gint) _tmp11__length1, _tmp13_, word_size, &_tmp14_);
				dividend = (g_free (dividend), NULL);
				dividend = _tmp15_;
				dividend_length1 = _tmp14_;
				_dividend_size_ = dividend_length1;
				_tmp16_ = dividend;
				_tmp16__length1 = dividend_length1;
				_tmp17_ = input_a[i];
				_tmp16_[63] = _tmp17_;
				_tmp18_ = dividend;
				_tmp18__length1 = dividend_length1;
				comparator_result = pebbles_programmer_comparator (self, _tmp18_, (gint) _tmp18__length1, input_b, (gint) input_b_length1, word_size);
				if (comparator_result == -1) {
					gboolean* _tmp19_;
					gint _tmp19__length1;
					_tmp19_ = self->output;
					_tmp19__length1 = self->output_length1;
					_tmp19_[i] = FALSE;
				} else {
					gboolean* _tmp20_;
					gint _tmp20__length1;
					gboolean* _tmp21_;
					gint _tmp21__length1;
					gint _tmp22_ = 0;
					gboolean* _tmp23_;
					_tmp20_ = self->output;
					_tmp20__length1 = self->output_length1;
					_tmp20_[i] = TRUE;
					_tmp21_ = dividend;
					_tmp21__length1 = dividend_length1;
					_tmp23_ = pebbles_programmer_subtract (self, _tmp21_, (gint) _tmp21__length1, input_b, (gint) input_b_length1, word_size, &_tmp22_);
					dividend = (g_free (dividend), NULL);
					dividend = _tmp23_;
					dividend_length1 = _tmp22_;
					_dividend_size_ = dividend_length1;
				}
			}
		}
	}
	_tmp24_ = self->output;
	_tmp24__length1 = self->output_length1;
	_tmp25_ = (_tmp24_ != NULL) ? _vala_array_dup24 (_tmp24_, _tmp24__length1) : _tmp24_;
	_tmp25__length1 = _tmp24__length1;
	_tmp26_ = _tmp25_;
	_tmp26__length1 = _tmp25__length1;
	if (result_length1) {
		*result_length1 = _tmp26__length1;
	}
	result = _tmp26_;
	shift_size = (g_free (shift_size), NULL);
	dividend = (g_free (dividend), NULL);
	return result;
}

static gint
pebbles_programmer_find_right_most_one (PebblesProgrammer* self,
                                        gboolean* input,
                                        gint input_length1)
{
	gint i = 0;
	gint result = 0;
	g_return_val_if_fail (self != NULL, 0);
	i = 0;
	{
		gboolean _tmp0_ = FALSE;
		_tmp0_ = TRUE;
		while (TRUE) {
			gboolean _tmp2_;
			if (!_tmp0_) {
				gint _tmp1_;
				_tmp1_ = i;
				i = _tmp1_ + 1;
			}
			_tmp0_ = FALSE;
			if (!(i < input_length1)) {
				break;
			}
			_tmp2_ = input[i];
			if (_tmp2_ == TRUE) {
				break;
			}
		}
	}
	result = input_length1 - i;
	return result;
}

/***
        compares two boolean arrays and returns an integer based on the following:
        a<b return -1
        a=b return 0
        a>b return 1
        */
gint
pebbles_programmer_comparator (PebblesProgrammer* self,
                               gboolean* input_a,
                               gint input_a_length1,
                               gboolean* input_b,
                               gint input_b_length1,
                               gint* word_size)
{
	gint result = 0;
	g_return_val_if_fail (self != NULL, 0);
	{
		gint i = 0;
		i = 64 - ((gint) (*word_size));
		{
			gboolean _tmp0_ = FALSE;
			_tmp0_ = TRUE;
			while (TRUE) {
				gboolean _tmp2_ = FALSE;
				gboolean _tmp3_;
				if (!_tmp0_) {
					gint _tmp1_;
					_tmp1_ = i;
					i = _tmp1_ + 1;
				}
				_tmp0_ = FALSE;
				if (!(i < 64)) {
					break;
				}
				_tmp3_ = input_a[i];
				if (_tmp3_ == FALSE) {
					gboolean _tmp4_;
					_tmp4_ = input_b[i];
					_tmp2_ = _tmp4_ == TRUE;
				} else {
					_tmp2_ = FALSE;
				}
				if (_tmp2_) {
					result = -1;
					return result;
				} else {
					gboolean _tmp5_;
					gboolean _tmp6_;
					_tmp5_ = input_a[i];
					_tmp6_ = input_b[i];
					if (_tmp5_ == _tmp6_) {
						continue;
					} else {
						result = 1;
						return result;
					}
				}
			}
		}
	}
	result = 0;
	return result;
}

static gboolean*
_vala_array_dup25 (gboolean* self,
                   gssize length)
{
	if (length > 0) {
		return _vala_memdup2 (self, length * sizeof (gboolean));
	}
	return NULL;
}

gboolean*
pebbles_programmer_left_shift (PebblesProgrammer* self,
                               gboolean* input_a,
                               gint input_a_length1,
                               gboolean* input_b,
                               gint input_b_length1,
                               gboolean fill_bits,
                               gint* word_size,
                               gint* result_length1)
{
	gint64 shift_amount = 0LL;
	gchar* shift_amount_binary_string = NULL;
	gchar* _tmp0_;
	const gchar* _tmp7_;
	gint64 _tmp8_ = 0LL;
	gboolean* _tmp13_;
	gint _tmp13__length1;
	gboolean* _tmp14_;
	gint _tmp14__length1;
	gboolean* _tmp15_;
	gint _tmp15__length1;
	gboolean* _tmp16_;
	gint _tmp16__length1;
	GError* _inner_error0_ = NULL;
	gboolean* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = g_strdup ("");
	shift_amount_binary_string = _tmp0_;
	{
		gint i = 0;
		i = 63;
		{
			gboolean _tmp1_ = FALSE;
			_tmp1_ = TRUE;
			while (TRUE) {
				const gchar* _tmp3_ = NULL;
				gboolean _tmp4_;
				const gchar* _tmp5_;
				gchar* _tmp6_;
				if (!_tmp1_) {
					gint _tmp2_;
					_tmp2_ = i;
					i = _tmp2_ - 1;
				}
				_tmp1_ = FALSE;
				if (!(i >= 0)) {
					break;
				}
				_tmp4_ = input_b[i];
				if (_tmp4_) {
					_tmp3_ = "1";
				} else {
					_tmp3_ = "0";
				}
				_tmp5_ = shift_amount_binary_string;
				_tmp6_ = g_strconcat (_tmp3_, _tmp5_, NULL);
				_g_free0 (shift_amount_binary_string);
				shift_amount_binary_string = _tmp6_;
			}
		}
	}
	_tmp7_ = shift_amount_binary_string;
	g_ascii_string_to_signed (_tmp7_, (guint) 2, G_MININT64, G_MAXINT64, &_tmp8_, &_inner_error0_);
	shift_amount = _tmp8_;
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		_g_free0 (shift_amount_binary_string);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return NULL;
	}
	if (shift_amount < ((gint64) 1)) {
		shift_amount = (gint64) 1;
	}
	if (shift_amount > (*word_size)) {
		shift_amount = *word_size;
	}
	{
		gint i = 0;
		i = (64 - ((gint) (*word_size))) + ((gint) shift_amount);
		{
			gboolean _tmp9_ = FALSE;
			_tmp9_ = TRUE;
			while (TRUE) {
				gboolean* _tmp11_;
				gint _tmp11__length1;
				gboolean _tmp12_;
				if (!_tmp9_) {
					gint _tmp10_;
					_tmp10_ = i;
					i = _tmp10_ + 1;
				}
				_tmp9_ = FALSE;
				if (!(i < 64)) {
					break;
				}
				_tmp11_ = self->output;
				_tmp11__length1 = self->output_length1;
				_tmp12_ = input_a[i];
				_tmp11_[i - shift_amount] = _tmp12_;
			}
		}
	}
	_tmp13_ = self->output;
	_tmp13__length1 = self->output_length1;
	_tmp13_[63] = fill_bits;
	_tmp14_ = self->output;
	_tmp14__length1 = self->output_length1;
	_tmp15_ = (_tmp14_ != NULL) ? _vala_array_dup25 (_tmp14_, _tmp14__length1) : _tmp14_;
	_tmp15__length1 = _tmp14__length1;
	_tmp16_ = _tmp15_;
	_tmp16__length1 = _tmp15__length1;
	if (result_length1) {
		*result_length1 = _tmp16__length1;
	}
	result = _tmp16_;
	_g_free0 (shift_amount_binary_string);
	return result;
}

static gboolean*
_vala_array_dup26 (gboolean* self,
                   gssize length)
{
	if (length > 0) {
		return _vala_memdup2 (self, length * sizeof (gboolean));
	}
	return NULL;
}

gboolean*
pebbles_programmer_right_shift (PebblesProgrammer* self,
                                gboolean* input_a,
                                gint input_a_length1,
                                gboolean* input_b,
                                gint input_b_length1,
                                gboolean fill_bits,
                                gint* word_size,
                                gint* result_length1)
{
	gint64 shift_amount = 0LL;
	gchar* shift_amount_binary_string = NULL;
	gchar* _tmp0_;
	const gchar* _tmp7_;
	gint64 _tmp8_ = 0LL;
	gboolean* _tmp13_;
	gint _tmp13__length1;
	gboolean* _tmp14_;
	gint _tmp14__length1;
	gboolean* _tmp15_;
	gint _tmp15__length1;
	gboolean* _tmp16_;
	gint _tmp16__length1;
	GError* _inner_error0_ = NULL;
	gboolean* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = g_strdup ("");
	shift_amount_binary_string = _tmp0_;
	{
		gint i = 0;
		i = 63;
		{
			gboolean _tmp1_ = FALSE;
			_tmp1_ = TRUE;
			while (TRUE) {
				const gchar* _tmp3_ = NULL;
				gboolean _tmp4_;
				const gchar* _tmp5_;
				gchar* _tmp6_;
				if (!_tmp1_) {
					gint _tmp2_;
					_tmp2_ = i;
					i = _tmp2_ - 1;
				}
				_tmp1_ = FALSE;
				if (!(i >= 0)) {
					break;
				}
				_tmp4_ = input_b[i];
				if (_tmp4_) {
					_tmp3_ = "1";
				} else {
					_tmp3_ = "0";
				}
				_tmp5_ = shift_amount_binary_string;
				_tmp6_ = g_strconcat (_tmp3_, _tmp5_, NULL);
				_g_free0 (shift_amount_binary_string);
				shift_amount_binary_string = _tmp6_;
			}
		}
	}
	_tmp7_ = shift_amount_binary_string;
	g_ascii_string_to_signed (_tmp7_, (guint) 2, G_MININT64, G_MAXINT64, &_tmp8_, &_inner_error0_);
	shift_amount = _tmp8_;
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		_g_free0 (shift_amount_binary_string);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return NULL;
	}
	if (shift_amount < ((gint64) 1)) {
		shift_amount = (gint64) 1;
	}
	if (shift_amount > (*word_size)) {
		shift_amount = *word_size;
	}
	{
		gint i = 0;
		i = 64 - (*word_size);
		{
			gboolean _tmp9_ = FALSE;
			_tmp9_ = TRUE;
			while (TRUE) {
				gboolean* _tmp11_;
				gint _tmp11__length1;
				gboolean _tmp12_;
				if (!_tmp9_) {
					gint _tmp10_;
					_tmp10_ = i;
					i = _tmp10_ + 1;
				}
				_tmp9_ = FALSE;
				if (!(((gint64) i) < (64 - shift_amount))) {
					break;
				}
				_tmp11_ = self->output;
				_tmp11__length1 = self->output_length1;
				_tmp12_ = input_a[i];
				_tmp11_[i + shift_amount] = _tmp12_;
			}
		}
	}
	_tmp13_ = self->output;
	_tmp13__length1 = self->output_length1;
	_tmp13_[0] = fill_bits;
	_tmp14_ = self->output;
	_tmp14__length1 = self->output_length1;
	_tmp15_ = (_tmp14_ != NULL) ? _vala_array_dup26 (_tmp14_, _tmp14__length1) : _tmp14_;
	_tmp15__length1 = _tmp14__length1;
	_tmp16_ = _tmp15_;
	_tmp16__length1 = _tmp15__length1;
	if (result_length1) {
		*result_length1 = _tmp16__length1;
	}
	result = _tmp16_;
	_g_free0 (shift_amount_binary_string);
	return result;
}

static gboolean*
_vala_array_dup27 (gboolean* self,
                   gssize length)
{
	if (length > 0) {
		return _vala_memdup2 (self, length * sizeof (gboolean));
	}
	return NULL;
}

gboolean*
pebbles_programmer_and (PebblesProgrammer* self,
                        gboolean* input_a,
                        gint input_a_length1,
                        gboolean* input_b,
                        gint input_b_length1,
                        gint* word_size,
                        gint* result_length1)
{
	gboolean* _tmp6_;
	gint _tmp6__length1;
	gboolean* _tmp7_;
	gint _tmp7__length1;
	gboolean* _tmp8_;
	gint _tmp8__length1;
	gboolean* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	{
		gint i = 0;
		i = 64 - ((gint) (*word_size));
		{
			gboolean _tmp0_ = FALSE;
			_tmp0_ = TRUE;
			while (TRUE) {
				gboolean _tmp2_ = FALSE;
				gboolean _tmp3_;
				gboolean* _tmp5_;
				gint _tmp5__length1;
				if (!_tmp0_) {
					gint _tmp1_;
					_tmp1_ = i;
					i = _tmp1_ + 1;
				}
				_tmp0_ = FALSE;
				if (!(i < 64)) {
					break;
				}
				_tmp3_ = input_a[i];
				if (_tmp3_) {
					gboolean _tmp4_;
					_tmp4_ = input_b[i];
					_tmp2_ = _tmp4_;
				} else {
					_tmp2_ = FALSE;
				}
				_tmp5_ = self->output;
				_tmp5__length1 = self->output_length1;
				_tmp5_[i] = _tmp2_;
			}
		}
	}
	_tmp6_ = self->output;
	_tmp6__length1 = self->output_length1;
	_tmp7_ = (_tmp6_ != NULL) ? _vala_array_dup27 (_tmp6_, _tmp6__length1) : _tmp6_;
	_tmp7__length1 = _tmp6__length1;
	_tmp8_ = _tmp7_;
	_tmp8__length1 = _tmp7__length1;
	if (result_length1) {
		*result_length1 = _tmp8__length1;
	}
	result = _tmp8_;
	return result;
}

static gboolean*
_vala_array_dup28 (gboolean* self,
                   gssize length)
{
	if (length > 0) {
		return _vala_memdup2 (self, length * sizeof (gboolean));
	}
	return NULL;
}

gboolean*
pebbles_programmer_nand (PebblesProgrammer* self,
                         gboolean* input_a,
                         gint input_a_length1,
                         gboolean* input_b,
                         gint input_b_length1,
                         gint* word_size,
                         gint* result_length1)
{
	gboolean* _tmp6_;
	gint _tmp6__length1;
	gboolean* _tmp7_;
	gint _tmp7__length1;
	gboolean* _tmp8_;
	gint _tmp8__length1;
	gboolean* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	{
		gint i = 0;
		i = 64 - ((gint) (*word_size));
		{
			gboolean _tmp0_ = FALSE;
			_tmp0_ = TRUE;
			while (TRUE) {
				gboolean _tmp2_ = FALSE;
				gboolean _tmp3_;
				gboolean* _tmp5_;
				gint _tmp5__length1;
				if (!_tmp0_) {
					gint _tmp1_;
					_tmp1_ = i;
					i = _tmp1_ + 1;
				}
				_tmp0_ = FALSE;
				if (!(i < 64)) {
					break;
				}
				_tmp3_ = input_a[i];
				if (_tmp3_) {
					gboolean _tmp4_;
					_tmp4_ = input_b[i];
					_tmp2_ = _tmp4_;
				} else {
					_tmp2_ = FALSE;
				}
				_tmp5_ = self->output;
				_tmp5__length1 = self->output_length1;
				_tmp5_[i] = !_tmp2_;
			}
		}
	}
	_tmp6_ = self->output;
	_tmp6__length1 = self->output_length1;
	_tmp7_ = (_tmp6_ != NULL) ? _vala_array_dup28 (_tmp6_, _tmp6__length1) : _tmp6_;
	_tmp7__length1 = _tmp6__length1;
	_tmp8_ = _tmp7_;
	_tmp8__length1 = _tmp7__length1;
	if (result_length1) {
		*result_length1 = _tmp8__length1;
	}
	result = _tmp8_;
	return result;
}

static gboolean*
_vala_array_dup29 (gboolean* self,
                   gssize length)
{
	if (length > 0) {
		return _vala_memdup2 (self, length * sizeof (gboolean));
	}
	return NULL;
}

gboolean*
pebbles_programmer_or (PebblesProgrammer* self,
                       gboolean* input_a,
                       gint input_a_length1,
                       gboolean* input_b,
                       gint input_b_length1,
                       gint* word_size,
                       gint* result_length1)
{
	gboolean* _tmp6_;
	gint _tmp6__length1;
	gboolean* _tmp7_;
	gint _tmp7__length1;
	gboolean* _tmp8_;
	gint _tmp8__length1;
	gboolean* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	{
		gint i = 0;
		i = 64 - ((gint) (*word_size));
		{
			gboolean _tmp0_ = FALSE;
			_tmp0_ = TRUE;
			while (TRUE) {
				gboolean _tmp2_ = FALSE;
				gboolean _tmp3_;
				gboolean* _tmp5_;
				gint _tmp5__length1;
				if (!_tmp0_) {
					gint _tmp1_;
					_tmp1_ = i;
					i = _tmp1_ + 1;
				}
				_tmp0_ = FALSE;
				if (!(i < 64)) {
					break;
				}
				_tmp3_ = input_a[i];
				if (_tmp3_) {
					_tmp2_ = TRUE;
				} else {
					gboolean _tmp4_;
					_tmp4_ = input_b[i];
					_tmp2_ = _tmp4_;
				}
				_tmp5_ = self->output;
				_tmp5__length1 = self->output_length1;
				_tmp5_[i] = _tmp2_;
			}
		}
	}
	_tmp6_ = self->output;
	_tmp6__length1 = self->output_length1;
	_tmp7_ = (_tmp6_ != NULL) ? _vala_array_dup29 (_tmp6_, _tmp6__length1) : _tmp6_;
	_tmp7__length1 = _tmp6__length1;
	_tmp8_ = _tmp7_;
	_tmp8__length1 = _tmp7__length1;
	if (result_length1) {
		*result_length1 = _tmp8__length1;
	}
	result = _tmp8_;
	return result;
}

static gboolean*
_vala_array_dup30 (gboolean* self,
                   gssize length)
{
	if (length > 0) {
		return _vala_memdup2 (self, length * sizeof (gboolean));
	}
	return NULL;
}

gboolean*
pebbles_programmer_nor (PebblesProgrammer* self,
                        gboolean* input_a,
                        gint input_a_length1,
                        gboolean* input_b,
                        gint input_b_length1,
                        gint* word_size,
                        gint* result_length1)
{
	gboolean* _tmp6_;
	gint _tmp6__length1;
	gboolean* _tmp7_;
	gint _tmp7__length1;
	gboolean* _tmp8_;
	gint _tmp8__length1;
	gboolean* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	{
		gint i = 0;
		i = 64 - ((gint) (*word_size));
		{
			gboolean _tmp0_ = FALSE;
			_tmp0_ = TRUE;
			while (TRUE) {
				gboolean _tmp2_ = FALSE;
				gboolean _tmp3_;
				gboolean* _tmp5_;
				gint _tmp5__length1;
				if (!_tmp0_) {
					gint _tmp1_;
					_tmp1_ = i;
					i = _tmp1_ + 1;
				}
				_tmp0_ = FALSE;
				if (!(i < 64)) {
					break;
				}
				_tmp3_ = input_a[i];
				if (_tmp3_) {
					_tmp2_ = TRUE;
				} else {
					gboolean _tmp4_;
					_tmp4_ = input_b[i];
					_tmp2_ = _tmp4_;
				}
				_tmp5_ = self->output;
				_tmp5__length1 = self->output_length1;
				_tmp5_[i] = !_tmp2_;
			}
		}
	}
	_tmp6_ = self->output;
	_tmp6__length1 = self->output_length1;
	_tmp7_ = (_tmp6_ != NULL) ? _vala_array_dup30 (_tmp6_, _tmp6__length1) : _tmp6_;
	_tmp7__length1 = _tmp6__length1;
	_tmp8_ = _tmp7_;
	_tmp8__length1 = _tmp7__length1;
	if (result_length1) {
		*result_length1 = _tmp8__length1;
	}
	result = _tmp8_;
	return result;
}

static gboolean*
_vala_array_dup31 (gboolean* self,
                   gssize length)
{
	if (length > 0) {
		return _vala_memdup2 (self, length * sizeof (gboolean));
	}
	return NULL;
}

gboolean*
pebbles_programmer_xor (PebblesProgrammer* self,
                        gboolean* input_a,
                        gint input_a_length1,
                        gboolean* input_b,
                        gint input_b_length1,
                        gint* word_size,
                        gint* result_length1)
{
	gboolean* _tmp5_;
	gint _tmp5__length1;
	gboolean* _tmp6_;
	gint _tmp6__length1;
	gboolean* _tmp7_;
	gint _tmp7__length1;
	gboolean* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	{
		gint i = 0;
		i = 64 - (*word_size);
		{
			gboolean _tmp0_ = FALSE;
			_tmp0_ = TRUE;
			while (TRUE) {
				gboolean* _tmp2_;
				gint _tmp2__length1;
				gboolean _tmp3_;
				gboolean _tmp4_;
				if (!_tmp0_) {
					gint _tmp1_;
					_tmp1_ = i;
					i = _tmp1_ + 1;
				}
				_tmp0_ = FALSE;
				if (!(i < 64)) {
					break;
				}
				_tmp2_ = self->output;
				_tmp2__length1 = self->output_length1;
				_tmp3_ = input_a[i];
				_tmp4_ = input_b[i];
				_tmp2_[i] = pebbles_programmer_xor_each_bit (self, _tmp3_, _tmp4_);
			}
		}
	}
	_tmp5_ = self->output;
	_tmp5__length1 = self->output_length1;
	_tmp6_ = (_tmp5_ != NULL) ? _vala_array_dup31 (_tmp5_, _tmp5__length1) : _tmp5_;
	_tmp6__length1 = _tmp5__length1;
	_tmp7_ = _tmp6_;
	_tmp7__length1 = _tmp6__length1;
	if (result_length1) {
		*result_length1 = _tmp7__length1;
	}
	result = _tmp7_;
	return result;
}

static gboolean*
_vala_array_dup32 (gboolean* self,
                   gssize length)
{
	if (length > 0) {
		return _vala_memdup2 (self, length * sizeof (gboolean));
	}
	return NULL;
}

gboolean*
pebbles_programmer_xnor (PebblesProgrammer* self,
                         gboolean* input_a,
                         gint input_a_length1,
                         gboolean* input_b,
                         gint input_b_length1,
                         gint* word_size,
                         gint* result_length1)
{
	gboolean* _tmp5_;
	gint _tmp5__length1;
	gboolean* _tmp6_;
	gint _tmp6__length1;
	gboolean* _tmp7_;
	gint _tmp7__length1;
	gboolean* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	{
		gint i = 0;
		i = 64 - ((gint) (*word_size));
		{
			gboolean _tmp0_ = FALSE;
			_tmp0_ = TRUE;
			while (TRUE) {
				gboolean* _tmp2_;
				gint _tmp2__length1;
				gboolean _tmp3_;
				gboolean _tmp4_;
				if (!_tmp0_) {
					gint _tmp1_;
					_tmp1_ = i;
					i = _tmp1_ + 1;
				}
				_tmp0_ = FALSE;
				if (!(i < 64)) {
					break;
				}
				_tmp2_ = self->output;
				_tmp2__length1 = self->output_length1;
				_tmp3_ = input_a[i];
				_tmp4_ = input_b[i];
				_tmp2_[i] = !pebbles_programmer_xor_each_bit (self, _tmp3_, _tmp4_);
			}
		}
	}
	_tmp5_ = self->output;
	_tmp5__length1 = self->output_length1;
	_tmp6_ = (_tmp5_ != NULL) ? _vala_array_dup32 (_tmp5_, _tmp5__length1) : _tmp5_;
	_tmp6__length1 = _tmp5__length1;
	_tmp7_ = _tmp6_;
	_tmp7__length1 = _tmp6__length1;
	if (result_length1) {
		*result_length1 = _tmp7__length1;
	}
	result = _tmp7_;
	return result;
}

static gboolean*
_vala_array_dup33 (gboolean* self,
                   gssize length)
{
	if (length > 0) {
		return _vala_memdup2 (self, length * sizeof (gboolean));
	}
	return NULL;
}

gboolean*
pebbles_programmer_not (PebblesProgrammer* self,
                        gboolean* input,
                        gint input_length1,
                        gint* word_size,
                        gint* result_length1)
{
	gint _tmp0_ = 0;
	gboolean* _tmp1_;
	gboolean* _tmp2_;
	gint _tmp2__length1;
	gboolean* _tmp3_;
	gint _tmp3__length1;
	gboolean* _tmp4_;
	gint _tmp4__length1;
	gboolean* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp1_ = pebbles_programmer_ones_complement (self, input, (gint) input_length1, word_size, &_tmp0_);
	self->output = (g_free (self->output), NULL);
	self->output = _tmp1_;
	self->output_length1 = _tmp0_;
	_tmp2_ = self->output;
	_tmp2__length1 = self->output_length1;
	_tmp3_ = (_tmp2_ != NULL) ? _vala_array_dup33 (_tmp2_, _tmp2__length1) : _tmp2_;
	_tmp3__length1 = _tmp2__length1;
	_tmp4_ = _tmp3_;
	_tmp4__length1 = _tmp3__length1;
	if (result_length1) {
		*result_length1 = _tmp4__length1;
	}
	result = _tmp4_;
	return result;
}

static void
pebbles_value_programmer_init (GValue* value)
{
	value->data[0].v_pointer = NULL;
}

static void
pebbles_value_programmer_free_value (GValue* value)
{
	if (value->data[0].v_pointer) {
		pebbles_programmer_unref (value->data[0].v_pointer);
	}
}

static void
pebbles_value_programmer_copy_value (const GValue* src_value,
                                     GValue* dest_value)
{
	if (src_value->data[0].v_pointer) {
		dest_value->data[0].v_pointer = pebbles_programmer_ref (src_value->data[0].v_pointer);
	} else {
		dest_value->data[0].v_pointer = NULL;
	}
}

static gpointer
pebbles_value_programmer_peek_pointer (const GValue* value)
{
	return value->data[0].v_pointer;
}

static gchar*
pebbles_value_programmer_collect_value (GValue* value,
                                        guint n_collect_values,
                                        GTypeCValue* collect_values,
                                        guint collect_flags)
{
	if (collect_values[0].v_pointer) {
		PebblesProgrammer * object;
		object = collect_values[0].v_pointer;
		if (object->parent_instance.g_class == NULL) {
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		}
		value->data[0].v_pointer = pebbles_programmer_ref (object);
	} else {
		value->data[0].v_pointer = NULL;
	}
	return NULL;
}

static gchar*
pebbles_value_programmer_lcopy_value (const GValue* value,
                                      guint n_collect_values,
                                      GTypeCValue* collect_values,
                                      guint collect_flags)
{
	PebblesProgrammer ** object_p;
	object_p = collect_values[0].v_pointer;
	if (!object_p) {
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
	}
	if (!value->data[0].v_pointer) {
		*object_p = NULL;
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
		*object_p = value->data[0].v_pointer;
	} else {
		*object_p = pebbles_programmer_ref (value->data[0].v_pointer);
	}
	return NULL;
}

GParamSpec*
pebbles_param_spec_programmer (const gchar* name,
                               const gchar* nick,
                               const gchar* blurb,
                               GType object_type,
                               GParamFlags flags)
{
	PebblesParamSpecProgrammer* spec;
	g_return_val_if_fail (g_type_is_a (object_type, PEBBLES_TYPE_PROGRAMMER), NULL);
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
	G_PARAM_SPEC (spec)->value_type = object_type;
	return G_PARAM_SPEC (spec);
}

gpointer
pebbles_value_get_programmer (const GValue* value)
{
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, PEBBLES_TYPE_PROGRAMMER), NULL);
	return value->data[0].v_pointer;
}

void
pebbles_value_set_programmer (GValue* value,
                              gpointer v_object)
{
	PebblesProgrammer * old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, PEBBLES_TYPE_PROGRAMMER));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, PEBBLES_TYPE_PROGRAMMER));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
		pebbles_programmer_ref (value->data[0].v_pointer);
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		pebbles_programmer_unref (old);
	}
}

void
pebbles_value_take_programmer (GValue* value,
                               gpointer v_object)
{
	PebblesProgrammer * old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, PEBBLES_TYPE_PROGRAMMER));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, PEBBLES_TYPE_PROGRAMMER));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		pebbles_programmer_unref (old);
	}
}

static void
pebbles_programmer_class_init (PebblesProgrammerClass * klass,
                               gpointer klass_data)
{
	pebbles_programmer_parent_class = g_type_class_peek_parent (klass);
	((PebblesProgrammerClass *) klass)->finalize = pebbles_programmer_finalize;
}

static void
pebbles_programmer_instance_init (PebblesProgrammer * self,
                                  gpointer klass)
{
	self->ref_count = 1;
}

static void
pebbles_programmer_finalize (PebblesProgrammer * obj)
{
	PebblesProgrammer * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, PEBBLES_TYPE_PROGRAMMER, PebblesProgrammer);
	g_signal_handlers_destroy (self);
	self->output = (g_free (self->output), NULL);
}

static GType
pebbles_programmer_get_type_once (void)
{
	static const GTypeValueTable g_define_type_value_table = { pebbles_value_programmer_init, pebbles_value_programmer_free_value, pebbles_value_programmer_copy_value, pebbles_value_programmer_peek_pointer, "p", pebbles_value_programmer_collect_value, "p", pebbles_value_programmer_lcopy_value };
	static const GTypeInfo g_define_type_info = { sizeof (PebblesProgrammerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) pebbles_programmer_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PebblesProgrammer), 0, (GInstanceInitFunc) pebbles_programmer_instance_init, &g_define_type_value_table };
	static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
	GType pebbles_programmer_type_id;
	pebbles_programmer_type_id = g_type_register_fundamental (g_type_fundamental_next (), "PebblesProgrammer", &g_define_type_info, &g_define_type_fundamental_info, 0);
	return pebbles_programmer_type_id;
}

GType
pebbles_programmer_get_type (void)
{
	static volatile gsize pebbles_programmer_type_id__volatile = 0;
	if (g_once_init_enter (&pebbles_programmer_type_id__volatile)) {
		GType pebbles_programmer_type_id;
		pebbles_programmer_type_id = pebbles_programmer_get_type_once ();
		g_once_init_leave (&pebbles_programmer_type_id__volatile, pebbles_programmer_type_id);
	}
	return pebbles_programmer_type_id__volatile;
}

gpointer
pebbles_programmer_ref (gpointer instance)
{
	PebblesProgrammer * self;
	self = instance;
	g_atomic_int_inc (&self->ref_count);
	return instance;
}

void
pebbles_programmer_unref (gpointer instance)
{
	PebblesProgrammer * self;
	self = instance;
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
		PEBBLES_PROGRAMMER_GET_CLASS (self)->finalize (self);
		g_type_free_instance ((GTypeInstance *) self);
	}
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

