/* Statistics.c generated by valac 0.53.2, the Vala compiler
 * generated from Statistics.vala, do not modify */

/*
* Copyright (c) 2017-2020 Subhadeep Jasu <subhajasu@gmail.com>
* Copyright (c) 2017-2020 Saunak Biswas <saunakbis97@gmail.com>
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public
* License as published by the Free Software Foundation; either
* version 3 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*
* Authored by: Saunak Biswas <saunakbis97@gmail.com>
*/

#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <float.h>
#include <math.h>
#include <gsl/gsl_sort_double.h>
#include <gobject/gvaluecollector.h>

#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define PEBBLES_TYPE_STATISTICS (pebbles_statistics_get_type ())
#define PEBBLES_STATISTICS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), PEBBLES_TYPE_STATISTICS, PebblesStatistics))
#define PEBBLES_STATISTICS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), PEBBLES_TYPE_STATISTICS, PebblesStatisticsClass))
#define PEBBLES_IS_STATISTICS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), PEBBLES_TYPE_STATISTICS))
#define PEBBLES_IS_STATISTICS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), PEBBLES_TYPE_STATISTICS))
#define PEBBLES_STATISTICS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), PEBBLES_TYPE_STATISTICS, PebblesStatisticsClass))

typedef struct _PebblesStatistics PebblesStatistics;
typedef struct _PebblesStatisticsClass PebblesStatisticsClass;
typedef struct _PebblesStatisticsPrivate PebblesStatisticsPrivate;
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _PebblesParamSpecStatistics PebblesParamSpecStatistics;

struct _PebblesStatistics {
	GTypeInstance parent_instance;
	volatile int ref_count;
	PebblesStatisticsPrivate * priv;
};

struct _PebblesStatisticsClass {
	GTypeClass parent_class;
	void (*finalize) (PebblesStatistics *self);
};

struct _PebblesStatisticsPrivate {
	gchar** tokens;
	gint tokens_length1;
	gint _tokens_size_;
	gdouble* x;
	gint x_length1;
	gint _x_size_;
	gint decimal_places;
};

struct _PebblesParamSpecStatistics {
	GParamSpec parent_instance;
};

static gint PebblesStatistics_private_offset;
static gpointer pebbles_statistics_parent_class = NULL;

VALA_EXTERN gpointer pebbles_statistics_ref (gpointer instance);
VALA_EXTERN void pebbles_statistics_unref (gpointer instance);
VALA_EXTERN GParamSpec* pebbles_param_spec_statistics (const gchar* name,
                                           const gchar* nick,
                                           const gchar* blurb,
                                           GType object_type,
                                           GParamFlags flags);
VALA_EXTERN void pebbles_value_set_statistics (GValue* value,
                                   gpointer v_object);
VALA_EXTERN void pebbles_value_take_statistics (GValue* value,
                                    gpointer v_object);
VALA_EXTERN gpointer pebbles_value_get_statistics (const GValue* value);
VALA_EXTERN GType pebbles_statistics_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (PebblesStatistics, pebbles_statistics_unref)
VALA_EXTERN PebblesStatistics* pebbles_statistics_new (gint decimal_places);
VALA_EXTERN PebblesStatistics* pebbles_statistics_construct (GType object_type,
                                                 gint decimal_places);
static void pebbles_statistics_string_splitter (PebblesStatistics* self,
                                         const gchar* input_vals);
static gchar* pebbles_statistics_output_to_string (PebblesStatistics* self,
                                            gdouble values);
VALA_EXTERN gchar* pebbles_utils_manage_decimal_places (gdouble _result_,
                                            gint accuracy);
VALA_EXTERN gchar* pebbles_statistics_summation_x (PebblesStatistics* self,
                                       const gchar* input_vals);
VALA_EXTERN gchar* pebbles_statistics_summation_x_square (PebblesStatistics* self,
                                              const gchar* input_vals);
VALA_EXTERN gchar* pebbles_statistics_mean_x (PebblesStatistics* self,
                                  const gchar* input_vals);
VALA_EXTERN gchar* pebbles_statistics_mean_x_square (PebblesStatistics* self,
                                         const gchar* input_vals);
VALA_EXTERN gchar* pebbles_statistics_median (PebblesStatistics* self,
                                  const gchar* input_vals);
VALA_EXTERN gchar* pebbles_statistics_mode (PebblesStatistics* self,
                                const gchar* input_vals);
VALA_EXTERN gchar* pebbles_statistics_geometric_mean (PebblesStatistics* self,
                                          const gchar* input_vals);
static gchar* pebbles_statistics_summation_x_minus_mean_whole_square (PebblesStatistics* self,
                                                               const gchar* input_vals);
VALA_EXTERN gchar* pebbles_statistics_sample_variance (PebblesStatistics* self,
                                           const gchar* input_vals);
VALA_EXTERN gchar* pebbles_statistics_sample_standard_deviation (PebblesStatistics* self,
                                                     const gchar* input_vals);
VALA_EXTERN gchar* pebbles_statistics_population_variance (PebblesStatistics* self,
                                               const gchar* input_vals);
VALA_EXTERN gchar* pebbles_statistics_population_standard_deviation (PebblesStatistics* self,
                                                         const gchar* input_vals);
static void pebbles_statistics_finalize (PebblesStatistics * obj);
static GType pebbles_statistics_get_type_once (void);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static gssize _vala_array_length (gpointer array);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

static inline gpointer
pebbles_statistics_get_instance_private (PebblesStatistics* self)
{
	return G_STRUCT_MEMBER_P (self, PebblesStatistics_private_offset);
}

PebblesStatistics*
pebbles_statistics_construct (GType object_type,
                              gint decimal_places)
{
	PebblesStatistics* self = NULL;
	self = (PebblesStatistics*) g_type_create_instance (object_type);
	self->priv->decimal_places = decimal_places;
	return self;
}

PebblesStatistics*
pebbles_statistics_new (gint decimal_places)
{
	return pebbles_statistics_construct (PEBBLES_TYPE_STATISTICS, decimal_places);
}

static gdouble
double_parse (const gchar* str)
{
	gdouble result = 0.0;
	g_return_val_if_fail (str != NULL, 0.0);
	result = g_ascii_strtod (str, NULL);
	return result;
}

static void
pebbles_statistics_string_splitter (PebblesStatistics* self,
                                    const gchar* input_vals)
{
	gchar** _tmp0_;
	gchar** _tmp1_;
	gchar** _tmp2_;
	gint _tmp2__length1;
	gdouble* _tmp3_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (input_vals != NULL);
	_tmp1_ = _tmp0_ = g_strsplit (input_vals, "[&&]", 0);
	self->priv->tokens = (_vala_array_free (self->priv->tokens, self->priv->tokens_length1, (GDestroyNotify) g_free), NULL);
	self->priv->tokens = _tmp1_;
	self->priv->tokens_length1 = _vala_array_length (_tmp0_);
	self->priv->_tokens_size_ = self->priv->tokens_length1;
	_tmp2_ = self->priv->tokens;
	_tmp2__length1 = self->priv->tokens_length1;
	_tmp3_ = g_new0 (gdouble, _tmp2__length1);
	self->priv->x = (g_free (self->priv->x), NULL);
	self->priv->x = _tmp3_;
	self->priv->x_length1 = _tmp2__length1;
	self->priv->_x_size_ = self->priv->x_length1;
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp4_ = FALSE;
			_tmp4_ = TRUE;
			while (TRUE) {
				gchar** _tmp6_;
				gint _tmp6__length1;
				gdouble* _tmp7_;
				gint _tmp7__length1;
				gchar** _tmp8_;
				gint _tmp8__length1;
				const gchar* _tmp9_;
				if (!_tmp4_) {
					gint _tmp5_;
					_tmp5_ = i;
					i = _tmp5_ + 1;
				}
				_tmp4_ = FALSE;
				_tmp6_ = self->priv->tokens;
				_tmp6__length1 = self->priv->tokens_length1;
				if (!(i < _tmp6__length1)) {
					break;
				}
				_tmp7_ = self->priv->x;
				_tmp7__length1 = self->priv->x_length1;
				_tmp8_ = self->priv->tokens;
				_tmp8__length1 = self->priv->tokens_length1;
				_tmp9_ = _tmp8_[i];
				_tmp7_[i] = double_parse (_tmp9_);
			}
		}
	}
}

static gchar*
string_slice (const gchar* self,
              glong start,
              glong end)
{
	glong string_length = 0L;
	gint _tmp0_;
	gint _tmp1_;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_ = FALSE;
	gchar* _tmp4_;
	gchar* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = strlen (self);
	_tmp1_ = _tmp0_;
	string_length = (glong) _tmp1_;
	if (start < ((glong) 0)) {
		start = string_length + start;
	}
	if (end < ((glong) 0)) {
		end = string_length + end;
	}
	if (start >= ((glong) 0)) {
		_tmp2_ = start <= string_length;
	} else {
		_tmp2_ = FALSE;
	}
	g_return_val_if_fail (_tmp2_, NULL);
	if (end >= ((glong) 0)) {
		_tmp3_ = end <= string_length;
	} else {
		_tmp3_ = FALSE;
	}
	g_return_val_if_fail (_tmp3_, NULL);
	g_return_val_if_fail (start <= end, NULL);
	_tmp4_ = g_strndup (((gchar*) self) + start, (gsize) (end - start));
	result = _tmp4_;
	return result;
}

static gchar*
pebbles_statistics_output_to_string (PebblesStatistics* self,
                                     gdouble values)
{
	gchar* output = NULL;
	gchar* _tmp0_;
	const gchar* _tmp4_;
	gchar* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = pebbles_utils_manage_decimal_places (values, self->priv->decimal_places);
	output = _tmp0_;
	while (TRUE) {
		const gchar* _tmp1_;
		const gchar* _tmp2_;
		gchar* _tmp3_;
		_tmp1_ = output;
		if (!g_str_has_suffix (_tmp1_, "0")) {
			break;
		}
		_tmp2_ = output;
		_tmp3_ = string_slice (_tmp2_, (glong) 0, (glong) -1);
		_g_free0 (output);
		output = _tmp3_;
	}
	_tmp4_ = output;
	if (g_str_has_suffix (_tmp4_, ".")) {
		const gchar* _tmp5_;
		gchar* _tmp6_;
		_tmp5_ = output;
		_tmp6_ = string_slice (_tmp5_, (glong) 0, (glong) -1);
		_g_free0 (output);
		output = _tmp6_;
	}
	result = output;
	return result;
}

gchar*
pebbles_statistics_summation_x (PebblesStatistics* self,
                                const gchar* input_vals)
{
	gdouble sum_x = 0.0;
	gchar* _tmp5_;
	gchar* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (input_vals != NULL, NULL);
	sum_x = 0.0;
	pebbles_statistics_string_splitter (self, input_vals);
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp0_ = FALSE;
			_tmp0_ = TRUE;
			while (TRUE) {
				gdouble* _tmp2_;
				gint _tmp2__length1;
				gdouble* _tmp3_;
				gint _tmp3__length1;
				gdouble _tmp4_;
				if (!_tmp0_) {
					gint _tmp1_;
					_tmp1_ = i;
					i = _tmp1_ + 1;
				}
				_tmp0_ = FALSE;
				_tmp2_ = self->priv->x;
				_tmp2__length1 = self->priv->x_length1;
				if (!(i < _tmp2__length1)) {
					break;
				}
				_tmp3_ = self->priv->x;
				_tmp3__length1 = self->priv->x_length1;
				_tmp4_ = _tmp3_[i];
				sum_x = sum_x + _tmp4_;
			}
		}
	}
	_tmp5_ = pebbles_statistics_output_to_string (self, sum_x);
	result = _tmp5_;
	return result;
}

gchar*
pebbles_statistics_summation_x_square (PebblesStatistics* self,
                                       const gchar* input_vals)
{
	gdouble sum_x_square = 0.0;
	gchar* _tmp5_;
	gchar* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (input_vals != NULL, NULL);
	sum_x_square = 0.0;
	pebbles_statistics_string_splitter (self, input_vals);
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp0_ = FALSE;
			_tmp0_ = TRUE;
			while (TRUE) {
				gdouble* _tmp2_;
				gint _tmp2__length1;
				gdouble* _tmp3_;
				gint _tmp3__length1;
				gdouble _tmp4_;
				if (!_tmp0_) {
					gint _tmp1_;
					_tmp1_ = i;
					i = _tmp1_ + 1;
				}
				_tmp0_ = FALSE;
				_tmp2_ = self->priv->x;
				_tmp2__length1 = self->priv->x_length1;
				if (!(i < _tmp2__length1)) {
					break;
				}
				_tmp3_ = self->priv->x;
				_tmp3__length1 = self->priv->x_length1;
				_tmp4_ = _tmp3_[i];
				sum_x_square = sum_x_square + pow (_tmp4_, (gdouble) 2);
			}
		}
	}
	_tmp5_ = pebbles_statistics_output_to_string (self, sum_x_square);
	result = _tmp5_;
	return result;
}

gchar*
pebbles_statistics_mean_x (PebblesStatistics* self,
                           const gchar* input_vals)
{
	gdouble avg_x = 0.0;
	gdouble* _tmp5_;
	gint _tmp5__length1;
	gchar* _tmp6_;
	gchar* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (input_vals != NULL, NULL);
	avg_x = 0.0;
	pebbles_statistics_string_splitter (self, input_vals);
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp0_ = FALSE;
			_tmp0_ = TRUE;
			while (TRUE) {
				gdouble* _tmp2_;
				gint _tmp2__length1;
				gdouble* _tmp3_;
				gint _tmp3__length1;
				gdouble _tmp4_;
				if (!_tmp0_) {
					gint _tmp1_;
					_tmp1_ = i;
					i = _tmp1_ + 1;
				}
				_tmp0_ = FALSE;
				_tmp2_ = self->priv->x;
				_tmp2__length1 = self->priv->x_length1;
				if (!(i < _tmp2__length1)) {
					break;
				}
				_tmp3_ = self->priv->x;
				_tmp3__length1 = self->priv->x_length1;
				_tmp4_ = _tmp3_[i];
				avg_x = avg_x + _tmp4_;
			}
		}
	}
	_tmp5_ = self->priv->x;
	_tmp5__length1 = self->priv->x_length1;
	_tmp6_ = pebbles_statistics_output_to_string (self, avg_x / _tmp5__length1);
	result = _tmp6_;
	return result;
}

gchar*
pebbles_statistics_mean_x_square (PebblesStatistics* self,
                                  const gchar* input_vals)
{
	gdouble avg_x_square = 0.0;
	gdouble* _tmp5_;
	gint _tmp5__length1;
	gchar* _tmp6_;
	gchar* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (input_vals != NULL, NULL);
	avg_x_square = 0.0;
	pebbles_statistics_string_splitter (self, input_vals);
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp0_ = FALSE;
			_tmp0_ = TRUE;
			while (TRUE) {
				gdouble* _tmp2_;
				gint _tmp2__length1;
				gdouble* _tmp3_;
				gint _tmp3__length1;
				gdouble _tmp4_;
				if (!_tmp0_) {
					gint _tmp1_;
					_tmp1_ = i;
					i = _tmp1_ + 1;
				}
				_tmp0_ = FALSE;
				_tmp2_ = self->priv->x;
				_tmp2__length1 = self->priv->x_length1;
				if (!(i < _tmp2__length1)) {
					break;
				}
				_tmp3_ = self->priv->x;
				_tmp3__length1 = self->priv->x_length1;
				_tmp4_ = _tmp3_[i];
				avg_x_square = avg_x_square + pow (_tmp4_, (gdouble) 2);
			}
		}
	}
	_tmp5_ = self->priv->x;
	_tmp5__length1 = self->priv->x_length1;
	_tmp6_ = pebbles_statistics_output_to_string (self, avg_x_square / _tmp5__length1);
	result = _tmp6_;
	return result;
}

gchar*
pebbles_statistics_median (PebblesStatistics* self,
                           const gchar* input_vals)
{
	gdouble* _tmp0_;
	gint _tmp0__length1;
	gdouble* _tmp1_;
	gint _tmp1__length1;
	gdouble* _tmp2_;
	gint _tmp2__length1;
	gchar* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (input_vals != NULL, NULL);
	pebbles_statistics_string_splitter (self, input_vals);
	_tmp0_ = self->priv->x;
	_tmp0__length1 = self->priv->x_length1;
	_tmp1_ = self->priv->x;
	_tmp1__length1 = self->priv->x_length1;
	gsl_sort (_tmp0_, (gsize) 1, (gsize) _tmp1__length1);
	_tmp2_ = self->priv->x;
	_tmp2__length1 = self->priv->x_length1;
	if ((_tmp2__length1 % 2) == 0) {
		gdouble* _tmp3_;
		gint _tmp3__length1;
		gdouble* _tmp4_;
		gint _tmp4__length1;
		gdouble _tmp5_;
		gchar* _tmp6_;
		gchar* _tmp7_;
		gchar* _tmp8_;
		gchar* _tmp9_;
		gdouble* _tmp10_;
		gint _tmp10__length1;
		gdouble* _tmp11_;
		gint _tmp11__length1;
		gdouble _tmp12_;
		gchar* _tmp13_;
		gchar* _tmp14_;
		gchar* _tmp15_;
		gchar* _tmp16_;
		_tmp3_ = self->priv->x;
		_tmp3__length1 = self->priv->x_length1;
		_tmp4_ = self->priv->x;
		_tmp4__length1 = self->priv->x_length1;
		_tmp5_ = _tmp3_[(_tmp4__length1 / 2) - 1];
		_tmp6_ = pebbles_statistics_output_to_string (self, _tmp5_);
		_tmp7_ = _tmp6_;
		_tmp8_ = g_strconcat (_tmp7_, ", ", NULL);
		_tmp9_ = _tmp8_;
		_tmp10_ = self->priv->x;
		_tmp10__length1 = self->priv->x_length1;
		_tmp11_ = self->priv->x;
		_tmp11__length1 = self->priv->x_length1;
		_tmp12_ = _tmp10_[_tmp11__length1 / 2];
		_tmp13_ = pebbles_statistics_output_to_string (self, _tmp12_);
		_tmp14_ = _tmp13_;
		_tmp15_ = g_strconcat (_tmp9_, _tmp14_, NULL);
		_tmp16_ = _tmp15_;
		_g_free0 (_tmp14_);
		_g_free0 (_tmp9_);
		_g_free0 (_tmp7_);
		result = _tmp16_;
		return result;
	} else {
		gdouble* _tmp17_;
		gint _tmp17__length1;
		gdouble* _tmp18_;
		gint _tmp18__length1;
		gdouble _tmp19_;
		gchar* _tmp20_;
		_tmp17_ = self->priv->x;
		_tmp17__length1 = self->priv->x_length1;
		_tmp18_ = self->priv->x;
		_tmp18__length1 = self->priv->x_length1;
		_tmp19_ = _tmp17_[_tmp18__length1 / 2];
		_tmp20_ = pebbles_statistics_output_to_string (self, _tmp19_);
		result = _tmp20_;
		return result;
	}
}

gchar*
pebbles_statistics_mode (PebblesStatistics* self,
                         const gchar* input_vals)
{
	gboolean _tmp0_ = FALSE;
	gdouble* element = NULL;
	gdouble* _tmp2_;
	gint _tmp2__length1;
	gdouble* _tmp3_;
	gint element_length1;
	gint _element_size_;
	gint no_of_elements = 0;
	gint max_frequency = 0;
	gchar* mode_elements = NULL;
	gdouble* _tmp19_;
	gint _tmp19__length1;
	gdouble _tmp20_;
	gchar* _tmp21_;
	gint flag = 0;
	gchar* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (input_vals != NULL, NULL);
	if (g_strcmp0 (input_vals, " ") == 0) {
		_tmp0_ = TRUE;
	} else {
		_tmp0_ = input_vals == NULL;
	}
	if (_tmp0_) {
		gchar* _tmp1_;
		_tmp1_ = g_strdup ("0");
		result = _tmp1_;
		return result;
	}
	pebbles_statistics_string_splitter (self, input_vals);
	_tmp2_ = self->priv->x;
	_tmp2__length1 = self->priv->x_length1;
	_tmp3_ = g_new0 (gdouble, _tmp2__length1);
	element = _tmp3_;
	element_length1 = _tmp2__length1;
	_element_size_ = element_length1;
	no_of_elements = 1;
	max_frequency = 0;
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp4_ = FALSE;
			_tmp4_ = TRUE;
			while (TRUE) {
				gdouble* _tmp6_;
				gint _tmp6__length1;
				gdouble temp_element = 0.0;
				gdouble* _tmp7_;
				gint _tmp7__length1;
				gdouble _tmp8_;
				gint temp_frequency = 0;
				if (!_tmp4_) {
					gint _tmp5_;
					_tmp5_ = i;
					i = _tmp5_ + 1;
				}
				_tmp4_ = FALSE;
				_tmp6_ = self->priv->x;
				_tmp6__length1 = self->priv->x_length1;
				if (!(i < _tmp6__length1)) {
					break;
				}
				_tmp7_ = self->priv->x;
				_tmp7__length1 = self->priv->x_length1;
				_tmp8_ = _tmp7_[i];
				temp_element = _tmp8_;
				temp_frequency = 0;
				{
					gint j = 0;
					j = 0;
					{
						gboolean _tmp9_ = FALSE;
						_tmp9_ = TRUE;
						while (TRUE) {
							gdouble* _tmp11_;
							gint _tmp11__length1;
							gdouble* _tmp12_;
							gint _tmp12__length1;
							gdouble _tmp13_;
							if (!_tmp9_) {
								gint _tmp10_;
								_tmp10_ = j;
								j = _tmp10_ + 1;
							}
							_tmp9_ = FALSE;
							_tmp11_ = self->priv->x;
							_tmp11__length1 = self->priv->x_length1;
							if (!(j < _tmp11__length1)) {
								break;
							}
							_tmp12_ = self->priv->x;
							_tmp12__length1 = self->priv->x_length1;
							_tmp13_ = _tmp12_[j];
							if (temp_element == _tmp13_) {
								temp_frequency = temp_frequency + 1;
							}
						}
					}
				}
				if (temp_frequency == max_frequency) {
					gdouble* _tmp14_;
					gint _tmp14__length1;
					no_of_elements = no_of_elements + 1;
					_tmp14_ = element;
					_tmp14__length1 = element_length1;
					_tmp14_[no_of_elements - 1] = temp_element;
				}
				if (temp_frequency > max_frequency) {
					gdouble* _tmp15_;
					gint _tmp15__length1;
					_tmp15_ = element;
					_tmp15__length1 = element_length1;
					_tmp15_[0] = temp_element;
					{
						gint j = 0;
						j = 1;
						{
							gboolean _tmp16_ = FALSE;
							_tmp16_ = TRUE;
							while (TRUE) {
								gdouble* _tmp18_;
								gint _tmp18__length1;
								if (!_tmp16_) {
									gint _tmp17_;
									_tmp17_ = j;
									j = _tmp17_ + 1;
								}
								_tmp16_ = FALSE;
								if (!(j < no_of_elements)) {
									break;
								}
								_tmp18_ = element;
								_tmp18__length1 = element_length1;
								_tmp18_[j] = (gdouble) 0;
							}
						}
					}
					no_of_elements = 1;
					max_frequency = temp_frequency;
				}
			}
		}
	}
	_tmp19_ = element;
	_tmp19__length1 = element_length1;
	_tmp20_ = _tmp19_[0];
	_tmp21_ = pebbles_statistics_output_to_string (self, _tmp20_);
	mode_elements = _tmp21_;
	flag = 0;
	{
		gint i = 0;
		i = 1;
		{
			gboolean _tmp22_ = FALSE;
			_tmp22_ = TRUE;
			while (TRUE) {
				if (!_tmp22_) {
					gint _tmp23_;
					_tmp23_ = i;
					i = _tmp23_ + 1;
				}
				_tmp22_ = FALSE;
				if (!(i < no_of_elements)) {
					break;
				}
				flag = 0;
				{
					gint j = 0;
					j = 0;
					{
						gboolean _tmp24_ = FALSE;
						_tmp24_ = TRUE;
						while (TRUE) {
							gdouble* _tmp26_;
							gint _tmp26__length1;
							gdouble _tmp27_;
							gdouble* _tmp28_;
							gint _tmp28__length1;
							gdouble _tmp29_;
							if (!_tmp24_) {
								gint _tmp25_;
								_tmp25_ = j;
								j = _tmp25_ + 1;
							}
							_tmp24_ = FALSE;
							if (!(j < i)) {
								break;
							}
							_tmp26_ = element;
							_tmp26__length1 = element_length1;
							_tmp27_ = _tmp26_[i];
							_tmp28_ = element;
							_tmp28__length1 = element_length1;
							_tmp29_ = _tmp28_[j];
							if (_tmp27_ == _tmp29_) {
								flag = 1;
								break;
							}
						}
					}
				}
				if (flag == 0) {
					const gchar* _tmp30_;
					gdouble* _tmp31_;
					gint _tmp31__length1;
					gdouble _tmp32_;
					gchar* _tmp33_;
					gchar* _tmp34_;
					gchar* _tmp35_;
					_tmp30_ = mode_elements;
					_tmp31_ = element;
					_tmp31__length1 = element_length1;
					_tmp32_ = _tmp31_[i];
					_tmp33_ = pebbles_statistics_output_to_string (self, _tmp32_);
					_tmp34_ = _tmp33_;
					_tmp35_ = g_strconcat (_tmp30_, ", ", _tmp34_, NULL);
					_g_free0 (mode_elements);
					mode_elements = _tmp35_;
					_g_free0 (_tmp34_);
				}
			}
		}
	}
	result = mode_elements;
	element = (g_free (element), NULL);
	return result;
}

gchar*
pebbles_statistics_geometric_mean (PebblesStatistics* self,
                                   const gchar* input_vals)
{
	gdouble geo_mean = 0.0;
	gdouble* _tmp5_;
	gint _tmp5__length1;
	gchar* _tmp6_;
	gchar* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (input_vals != NULL, NULL);
	pebbles_statistics_string_splitter (self, input_vals);
	geo_mean = (gdouble) 0;
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp0_ = FALSE;
			_tmp0_ = TRUE;
			while (TRUE) {
				gdouble* _tmp2_;
				gint _tmp2__length1;
				gdouble* _tmp3_;
				gint _tmp3__length1;
				gdouble _tmp4_;
				if (!_tmp0_) {
					gint _tmp1_;
					_tmp1_ = i;
					i = _tmp1_ + 1;
				}
				_tmp0_ = FALSE;
				_tmp2_ = self->priv->x;
				_tmp2__length1 = self->priv->x_length1;
				if (!(i < _tmp2__length1)) {
					break;
				}
				_tmp3_ = self->priv->x;
				_tmp3__length1 = self->priv->x_length1;
				_tmp4_ = _tmp3_[i];
				geo_mean = geo_mean + log (_tmp4_);
			}
		}
	}
	_tmp5_ = self->priv->x;
	_tmp5__length1 = self->priv->x_length1;
	geo_mean = geo_mean / _tmp5__length1;
	geo_mean = exp (geo_mean);
	_tmp6_ = pebbles_statistics_output_to_string (self, geo_mean);
	result = _tmp6_;
	return result;
}

static gchar*
pebbles_statistics_summation_x_minus_mean_whole_square (PebblesStatistics* self,
                                                        const gchar* input_vals)
{
	gdouble mean_of_x = 0.0;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gdouble _tmp2_;
	gdouble summation = 0.0;
	gchar* _tmp8_;
	gchar* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (input_vals != NULL, NULL);
	_tmp0_ = pebbles_statistics_mean_x (self, input_vals);
	_tmp1_ = _tmp0_;
	_tmp2_ = double_parse (_tmp1_);
	_g_free0 (_tmp1_);
	mean_of_x = _tmp2_;
	summation = 0.0;
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp3_ = FALSE;
			_tmp3_ = TRUE;
			while (TRUE) {
				gdouble* _tmp5_;
				gint _tmp5__length1;
				gdouble* _tmp6_;
				gint _tmp6__length1;
				gdouble _tmp7_;
				if (!_tmp3_) {
					gint _tmp4_;
					_tmp4_ = i;
					i = _tmp4_ + 1;
				}
				_tmp3_ = FALSE;
				_tmp5_ = self->priv->x;
				_tmp5__length1 = self->priv->x_length1;
				if (!(i < _tmp5__length1)) {
					break;
				}
				_tmp6_ = self->priv->x;
				_tmp6__length1 = self->priv->x_length1;
				_tmp7_ = _tmp6_[i];
				summation = summation + pow (_tmp7_ - mean_of_x, (gdouble) 2);
			}
		}
	}
	_tmp8_ = pebbles_statistics_output_to_string (self, summation);
	result = _tmp8_;
	return result;
}

gchar*
pebbles_statistics_sample_variance (PebblesStatistics* self,
                                    const gchar* input_vals)
{
	gdouble variance = 0.0;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gdouble _tmp2_;
	gdouble* _tmp3_;
	gint _tmp3__length1;
	gchar* _tmp4_;
	gchar* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (input_vals != NULL, NULL);
	_tmp0_ = pebbles_statistics_summation_x_minus_mean_whole_square (self, input_vals);
	_tmp1_ = _tmp0_;
	_tmp2_ = double_parse (_tmp1_);
	_g_free0 (_tmp1_);
	variance = _tmp2_;
	_tmp3_ = self->priv->x;
	_tmp3__length1 = self->priv->x_length1;
	variance = variance / (_tmp3__length1 - 1);
	_tmp4_ = pebbles_statistics_output_to_string (self, variance);
	result = _tmp4_;
	return result;
}

gchar*
pebbles_statistics_sample_standard_deviation (PebblesStatistics* self,
                                              const gchar* input_vals)
{
	gdouble standard_deviation = 0.0;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gdouble _tmp2_;
	gchar* _tmp3_;
	gchar* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (input_vals != NULL, NULL);
	_tmp0_ = pebbles_statistics_sample_variance (self, input_vals);
	_tmp1_ = _tmp0_;
	_tmp2_ = double_parse (_tmp1_);
	_g_free0 (_tmp1_);
	standard_deviation = _tmp2_;
	standard_deviation = sqrt (standard_deviation);
	_tmp3_ = pebbles_statistics_output_to_string (self, standard_deviation);
	result = _tmp3_;
	return result;
}

gchar*
pebbles_statistics_population_variance (PebblesStatistics* self,
                                        const gchar* input_vals)
{
	gdouble variance = 0.0;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gdouble _tmp2_;
	gdouble* _tmp3_;
	gint _tmp3__length1;
	gchar* _tmp4_;
	gchar* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (input_vals != NULL, NULL);
	_tmp0_ = pebbles_statistics_summation_x_minus_mean_whole_square (self, input_vals);
	_tmp1_ = _tmp0_;
	_tmp2_ = double_parse (_tmp1_);
	_g_free0 (_tmp1_);
	variance = _tmp2_;
	_tmp3_ = self->priv->x;
	_tmp3__length1 = self->priv->x_length1;
	variance = variance / _tmp3__length1;
	_tmp4_ = pebbles_statistics_output_to_string (self, variance);
	result = _tmp4_;
	return result;
}

gchar*
pebbles_statistics_population_standard_deviation (PebblesStatistics* self,
                                                  const gchar* input_vals)
{
	gdouble standard_deviation = 0.0;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gdouble _tmp2_;
	gchar* _tmp3_;
	gchar* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (input_vals != NULL, NULL);
	_tmp0_ = pebbles_statistics_population_variance (self, input_vals);
	_tmp1_ = _tmp0_;
	_tmp2_ = double_parse (_tmp1_);
	_g_free0 (_tmp1_);
	standard_deviation = _tmp2_;
	standard_deviation = sqrt (standard_deviation);
	_tmp3_ = pebbles_statistics_output_to_string (self, standard_deviation);
	result = _tmp3_;
	return result;
}

static void
pebbles_value_statistics_init (GValue* value)
{
	value->data[0].v_pointer = NULL;
}

static void
pebbles_value_statistics_free_value (GValue* value)
{
	if (value->data[0].v_pointer) {
		pebbles_statistics_unref (value->data[0].v_pointer);
	}
}

static void
pebbles_value_statistics_copy_value (const GValue* src_value,
                                     GValue* dest_value)
{
	if (src_value->data[0].v_pointer) {
		dest_value->data[0].v_pointer = pebbles_statistics_ref (src_value->data[0].v_pointer);
	} else {
		dest_value->data[0].v_pointer = NULL;
	}
}

static gpointer
pebbles_value_statistics_peek_pointer (const GValue* value)
{
	return value->data[0].v_pointer;
}

static gchar*
pebbles_value_statistics_collect_value (GValue* value,
                                        guint n_collect_values,
                                        GTypeCValue* collect_values,
                                        guint collect_flags)
{
	if (collect_values[0].v_pointer) {
		PebblesStatistics * object;
		object = collect_values[0].v_pointer;
		if (object->parent_instance.g_class == NULL) {
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		}
		value->data[0].v_pointer = pebbles_statistics_ref (object);
	} else {
		value->data[0].v_pointer = NULL;
	}
	return NULL;
}

static gchar*
pebbles_value_statistics_lcopy_value (const GValue* value,
                                      guint n_collect_values,
                                      GTypeCValue* collect_values,
                                      guint collect_flags)
{
	PebblesStatistics ** object_p;
	object_p = collect_values[0].v_pointer;
	if (!object_p) {
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
	}
	if (!value->data[0].v_pointer) {
		*object_p = NULL;
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
		*object_p = value->data[0].v_pointer;
	} else {
		*object_p = pebbles_statistics_ref (value->data[0].v_pointer);
	}
	return NULL;
}

GParamSpec*
pebbles_param_spec_statistics (const gchar* name,
                               const gchar* nick,
                               const gchar* blurb,
                               GType object_type,
                               GParamFlags flags)
{
	PebblesParamSpecStatistics* spec;
	g_return_val_if_fail (g_type_is_a (object_type, PEBBLES_TYPE_STATISTICS), NULL);
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
	G_PARAM_SPEC (spec)->value_type = object_type;
	return G_PARAM_SPEC (spec);
}

gpointer
pebbles_value_get_statistics (const GValue* value)
{
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, PEBBLES_TYPE_STATISTICS), NULL);
	return value->data[0].v_pointer;
}

void
pebbles_value_set_statistics (GValue* value,
                              gpointer v_object)
{
	PebblesStatistics * old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, PEBBLES_TYPE_STATISTICS));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, PEBBLES_TYPE_STATISTICS));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
		pebbles_statistics_ref (value->data[0].v_pointer);
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		pebbles_statistics_unref (old);
	}
}

void
pebbles_value_take_statistics (GValue* value,
                               gpointer v_object)
{
	PebblesStatistics * old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, PEBBLES_TYPE_STATISTICS));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, PEBBLES_TYPE_STATISTICS));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		pebbles_statistics_unref (old);
	}
}

static void
pebbles_statistics_class_init (PebblesStatisticsClass * klass,
                               gpointer klass_data)
{
	pebbles_statistics_parent_class = g_type_class_peek_parent (klass);
	((PebblesStatisticsClass *) klass)->finalize = pebbles_statistics_finalize;
	g_type_class_adjust_private_offset (klass, &PebblesStatistics_private_offset);
}

static void
pebbles_statistics_instance_init (PebblesStatistics * self,
                                  gpointer klass)
{
	self->priv = pebbles_statistics_get_instance_private (self);
	self->ref_count = 1;
}

static void
pebbles_statistics_finalize (PebblesStatistics * obj)
{
	PebblesStatistics * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, PEBBLES_TYPE_STATISTICS, PebblesStatistics);
	g_signal_handlers_destroy (self);
	self->priv->tokens = (_vala_array_free (self->priv->tokens, self->priv->tokens_length1, (GDestroyNotify) g_free), NULL);
	self->priv->x = (g_free (self->priv->x), NULL);
}

static GType
pebbles_statistics_get_type_once (void)
{
	static const GTypeValueTable g_define_type_value_table = { pebbles_value_statistics_init, pebbles_value_statistics_free_value, pebbles_value_statistics_copy_value, pebbles_value_statistics_peek_pointer, "p", pebbles_value_statistics_collect_value, "p", pebbles_value_statistics_lcopy_value };
	static const GTypeInfo g_define_type_info = { sizeof (PebblesStatisticsClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) pebbles_statistics_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PebblesStatistics), 0, (GInstanceInitFunc) pebbles_statistics_instance_init, &g_define_type_value_table };
	static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
	GType pebbles_statistics_type_id;
	pebbles_statistics_type_id = g_type_register_fundamental (g_type_fundamental_next (), "PebblesStatistics", &g_define_type_info, &g_define_type_fundamental_info, 0);
	PebblesStatistics_private_offset = g_type_add_instance_private (pebbles_statistics_type_id, sizeof (PebblesStatisticsPrivate));
	return pebbles_statistics_type_id;
}

GType
pebbles_statistics_get_type (void)
{
	static volatile gsize pebbles_statistics_type_id__volatile = 0;
	if (g_once_init_enter (&pebbles_statistics_type_id__volatile)) {
		GType pebbles_statistics_type_id;
		pebbles_statistics_type_id = pebbles_statistics_get_type_once ();
		g_once_init_leave (&pebbles_statistics_type_id__volatile, pebbles_statistics_type_id);
	}
	return pebbles_statistics_type_id__volatile;
}

gpointer
pebbles_statistics_ref (gpointer instance)
{
	PebblesStatistics * self;
	self = instance;
	g_atomic_int_inc (&self->ref_count);
	return instance;
}

void
pebbles_statistics_unref (gpointer instance)
{
	PebblesStatistics * self;
	self = instance;
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
		PEBBLES_STATISTICS_GET_CLASS (self)->finalize (self);
		g_type_free_instance ((GTypeInstance *) self);
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gssize
_vala_array_length (gpointer array)
{
	gssize length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

