/* StatisticsGraph.c generated by valac 0.53.2, the Vala compiler
 * generated from StatisticsGraph.vala, do not modify */

/*-
 * Copyright (c) 2017-2020 Subhadeep Jasu <subhajasu@gmail.com>
 * Copyright (c) 2017-2020 Saunak Biswas  <saunakbis97@gmail.com>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation; either
 * version 3 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License 
 * along with this program. If not, see <https://www.gnu.org/licenses/>.
 *
 * Authored by: Subhadeep Jasu <subhajasu@gmail.com>
 */

#include <gtk/gtk.h>
#include <glib-object.h>
#include <glib.h>
#include <float.h>
#include <math.h>
#include <stdlib.h>
#include <string.h>
#include <cairo-gobject.h>

#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define PEBBLES_TYPE_STATISTICS_GRAPH (pebbles_statistics_graph_get_type ())
#define PEBBLES_STATISTICS_GRAPH(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), PEBBLES_TYPE_STATISTICS_GRAPH, PebblesStatisticsGraph))
#define PEBBLES_STATISTICS_GRAPH_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), PEBBLES_TYPE_STATISTICS_GRAPH, PebblesStatisticsGraphClass))
#define PEBBLES_IS_STATISTICS_GRAPH(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), PEBBLES_TYPE_STATISTICS_GRAPH))
#define PEBBLES_IS_STATISTICS_GRAPH_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), PEBBLES_TYPE_STATISTICS_GRAPH))
#define PEBBLES_STATISTICS_GRAPH_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), PEBBLES_TYPE_STATISTICS_GRAPH, PebblesStatisticsGraphClass))

typedef struct _PebblesStatisticsGraph PebblesStatisticsGraph;
typedef struct _PebblesStatisticsGraphClass PebblesStatisticsGraphClass;
typedef struct _PebblesStatisticsGraphPrivate PebblesStatisticsGraphPrivate;
enum  {
	PEBBLES_STATISTICS_GRAPH_0_PROPERTY,
	PEBBLES_STATISTICS_GRAPH_NUM_PROPERTIES
};
static GParamSpec* pebbles_statistics_graph_properties[PEBBLES_STATISTICS_GRAPH_NUM_PROPERTIES];

struct _PebblesStatisticsGraph {
	GtkDrawingArea parent_instance;
	PebblesStatisticsGraphPrivate * priv;
};

struct _PebblesStatisticsGraphClass {
	GtkDrawingAreaClass parent_class;
};

struct _PebblesStatisticsGraphPrivate {
	gint cardinality;
	gdouble* data_set;
	gint data_set_length1;
	gint _data_set_size_;
};

static gint PebblesStatisticsGraph_private_offset;
static gpointer pebbles_statistics_graph_parent_class = NULL;

VALA_EXTERN GType pebbles_statistics_graph_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (PebblesStatisticsGraph, g_object_unref)
VALA_EXTERN void pebbles_statistics_graph_set_data_set (PebblesStatisticsGraph* self,
                                            gchar** data_points,
                                            gint data_points_length1);
VALA_EXTERN PebblesStatisticsGraph* pebbles_statistics_graph_new (void);
VALA_EXTERN PebblesStatisticsGraph* pebbles_statistics_graph_construct (GType object_type);
static gboolean pebbles_statistics_graph_on_draw (PebblesStatisticsGraph* self,
                                           GtkWidget* widget,
                                           cairo_t* context);
static gboolean _pebbles_statistics_graph_on_draw_gtk_widget_draw (GtkWidget* _sender,
                                                            cairo_t* cr,
                                                            gpointer self);
static gdouble pebbles_statistics_graph_highest_point (PebblesStatisticsGraph* self,
                                                gdouble* arr,
                                                gint arr_length1);
static gdouble pebbles_statistics_graph_lowest_point (PebblesStatisticsGraph* self,
                                               gdouble* arr,
                                               gint arr_length1);
static void pebbles_statistics_graph_draw_bar (PebblesStatisticsGraph* self,
                                        cairo_t* ctx,
                                        gint width,
                                        gint height,
                                        gint x_offset,
                                        gint y_offset);
static void pebbles_statistics_graph_finalize (GObject * obj);
static GType pebbles_statistics_graph_get_type_once (void);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

static inline gpointer
pebbles_statistics_graph_get_instance_private (PebblesStatisticsGraph* self)
{
	return G_STRUCT_MEMBER_P (self, PebblesStatisticsGraph_private_offset);
}

static gdouble
double_parse (const gchar* str)
{
	gdouble result = 0.0;
	g_return_val_if_fail (str != NULL, 0.0);
	result = g_ascii_strtod (str, NULL);
	return result;
}

void
pebbles_statistics_graph_set_data_set (PebblesStatisticsGraph* self,
                                       gchar** data_points,
                                       gint data_points_length1)
{
	gdouble* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = g_new0 (gdouble, data_points_length1);
	self->priv->data_set = (g_free (self->priv->data_set), NULL);
	self->priv->data_set = _tmp0_;
	self->priv->data_set_length1 = data_points_length1;
	self->priv->_data_set_size_ = self->priv->data_set_length1;
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp1_ = FALSE;
			_tmp1_ = TRUE;
			while (TRUE) {
				gdouble* _tmp3_;
				gint _tmp3__length1;
				const gchar* _tmp4_;
				if (!_tmp1_) {
					gint _tmp2_;
					_tmp2_ = i;
					i = _tmp2_ + 1;
				}
				_tmp1_ = FALSE;
				if (!(i < data_points_length1)) {
					break;
				}
				_tmp3_ = self->priv->data_set;
				_tmp3__length1 = self->priv->data_set_length1;
				_tmp4_ = data_points[i];
				_tmp3_[i] = double_parse (_tmp4_);
			}
		}
	}
	self->priv->cardinality = data_points_length1;
}

static gboolean
_pebbles_statistics_graph_on_draw_gtk_widget_draw (GtkWidget* _sender,
                                                   cairo_t* cr,
                                                   gpointer self)
{
	gboolean result;
	result = pebbles_statistics_graph_on_draw ((PebblesStatisticsGraph*) self, _sender, cr);
	return result;
}

PebblesStatisticsGraph*
pebbles_statistics_graph_construct (GType object_type)
{
	PebblesStatisticsGraph * self = NULL;
	self = (PebblesStatisticsGraph*) g_object_new (object_type, NULL);
	g_signal_connect_object ((GtkWidget*) self, "draw", (GCallback) _pebbles_statistics_graph_on_draw_gtk_widget_draw, self, 0);
	g_object_set ((GtkWidget*) self, "width-request", 140, NULL);
	gtk_widget_queue_draw ((GtkWidget*) self);
	gtk_widget_show_all ((GtkWidget*) self);
	return self;
}

PebblesStatisticsGraph*
pebbles_statistics_graph_new (void)
{
	return pebbles_statistics_graph_construct (PEBBLES_TYPE_STATISTICS_GRAPH);
}

static gboolean
pebbles_statistics_graph_on_draw (PebblesStatisticsGraph* self,
                                  GtkWidget* widget,
                                  cairo_t* context)
{
	gboolean _tmp0_ = FALSE;
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (widget != NULL, FALSE);
	g_return_val_if_fail (context != NULL, FALSE);
	cairo_set_source_rgba (context, 0.152941176, 0.156862745, 0.388235294, 0.8);
	if (self->priv->cardinality != 0) {
		gdouble* _tmp1_;
		gint _tmp1__length1;
		_tmp1_ = self->priv->data_set;
		_tmp1__length1 = self->priv->data_set_length1;
		_tmp0_ = _tmp1_ != NULL;
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		gdouble max_point = 0.0;
		gdouble* _tmp2_;
		gint _tmp2__length1;
		gdouble min_point = 0.0;
		gdouble* _tmp3_;
		gint _tmp3__length1;
		gdouble max_height = 0.0;
		gint baseline = 0;
		gdouble line_width = 0.0;
		gdouble gap = 0.0;
		_tmp2_ = self->priv->data_set;
		_tmp2__length1 = self->priv->data_set_length1;
		max_point = pebbles_statistics_graph_highest_point (self, _tmp2_, (gint) _tmp2__length1);
		_tmp3_ = self->priv->data_set;
		_tmp3__length1 = self->priv->data_set_length1;
		min_point = pebbles_statistics_graph_lowest_point (self, _tmp3_, (gint) _tmp3__length1);
		max_height = max_point - min_point;
		baseline = (gint) ((-gtk_widget_get_allocated_height ((GtkWidget*) self)) * (min_point / max_height));
		line_width = (gdouble) (gtk_widget_get_allocated_width ((GtkWidget*) self) / self->priv->cardinality);
		gap = CLAMP (line_width / 4, (gdouble) 0, (gdouble) 2);
		{
			gint i = 0;
			i = 0;
			{
				gboolean _tmp4_ = FALSE;
				_tmp4_ = TRUE;
				while (TRUE) {
					gdouble* _tmp6_;
					gint _tmp6__length1;
					gdouble _tmp7_;
					if (!_tmp4_) {
						gint _tmp5_;
						_tmp5_ = i;
						i = _tmp5_ + 1;
					}
					_tmp4_ = FALSE;
					if (!(i < self->priv->cardinality)) {
						break;
					}
					_tmp6_ = self->priv->data_set;
					_tmp6__length1 = self->priv->data_set_length1;
					_tmp7_ = _tmp6_[i];
					pebbles_statistics_graph_draw_bar (self, context, (gint) (line_width - gap), (gint) ((_tmp7_ / max_height) * gtk_widget_get_allocated_height ((GtkWidget*) self)), (gint) (i * line_width), baseline);
				}
			}
		}
	}
	result = TRUE;
	return result;
}

static void
pebbles_statistics_graph_draw_bar (PebblesStatisticsGraph* self,
                                   cairo_t* ctx,
                                   gint width,
                                   gint height,
                                   gint x_offset,
                                   gint y_offset)
{
	g_return_if_fail (self != NULL);
	g_return_if_fail (ctx != NULL);
	cairo_set_line_width (ctx, (gdouble) width);
	cairo_move_to (ctx, (gdouble) (x_offset + (width / 2)), (gdouble) ((2 + gtk_widget_get_allocated_height ((GtkWidget*) self)) - y_offset));
	cairo_line_to (ctx, (gdouble) (x_offset + (width / 2)), (gdouble) ((2 + gtk_widget_get_allocated_height ((GtkWidget*) self)) - (height + y_offset)));
	cairo_stroke (ctx);
}

static gdouble
pebbles_statistics_graph_lowest_point (PebblesStatisticsGraph* self,
                                       gdouble* arr,
                                       gint arr_length1)
{
	gdouble x = 0.0;
	gdouble result = 0.0;
	g_return_val_if_fail (self != NULL, 0.0);
	x = (gdouble) 0;
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp0_ = FALSE;
			_tmp0_ = TRUE;
			while (TRUE) {
				gdouble _tmp2_;
				if (!_tmp0_) {
					gint _tmp1_;
					_tmp1_ = i;
					i = _tmp1_ + 1;
				}
				_tmp0_ = FALSE;
				if (!(i < arr_length1)) {
					break;
				}
				_tmp2_ = arr[i];
				if (_tmp2_ < x) {
					gdouble _tmp3_;
					_tmp3_ = arr[i];
					x = _tmp3_;
				}
			}
		}
	}
	result = x;
	return result;
}

static gdouble
pebbles_statistics_graph_highest_point (PebblesStatisticsGraph* self,
                                        gdouble* arr,
                                        gint arr_length1)
{
	gdouble x = 0.0;
	gdouble result = 0.0;
	g_return_val_if_fail (self != NULL, 0.0);
	x = (gdouble) 0;
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp0_ = FALSE;
			_tmp0_ = TRUE;
			while (TRUE) {
				gdouble _tmp2_;
				if (!_tmp0_) {
					gint _tmp1_;
					_tmp1_ = i;
					i = _tmp1_ + 1;
				}
				_tmp0_ = FALSE;
				if (!(i < arr_length1)) {
					break;
				}
				_tmp2_ = arr[i];
				if (_tmp2_ > x) {
					gdouble _tmp3_;
					_tmp3_ = arr[i];
					x = _tmp3_;
				}
			}
		}
	}
	result = x;
	return result;
}

static void
pebbles_statistics_graph_class_init (PebblesStatisticsGraphClass * klass,
                                     gpointer klass_data)
{
	pebbles_statistics_graph_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &PebblesStatisticsGraph_private_offset);
	G_OBJECT_CLASS (klass)->finalize = pebbles_statistics_graph_finalize;
}

static void
pebbles_statistics_graph_instance_init (PebblesStatisticsGraph * self,
                                        gpointer klass)
{
	self->priv = pebbles_statistics_graph_get_instance_private (self);
}

static void
pebbles_statistics_graph_finalize (GObject * obj)
{
	PebblesStatisticsGraph * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, PEBBLES_TYPE_STATISTICS_GRAPH, PebblesStatisticsGraph);
	self->priv->data_set = (g_free (self->priv->data_set), NULL);
	G_OBJECT_CLASS (pebbles_statistics_graph_parent_class)->finalize (obj);
}

static GType
pebbles_statistics_graph_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (PebblesStatisticsGraphClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) pebbles_statistics_graph_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PebblesStatisticsGraph), 0, (GInstanceInitFunc) pebbles_statistics_graph_instance_init, NULL };
	GType pebbles_statistics_graph_type_id;
	pebbles_statistics_graph_type_id = g_type_register_static (gtk_drawing_area_get_type (), "PebblesStatisticsGraph", &g_define_type_info, 0);
	PebblesStatisticsGraph_private_offset = g_type_add_instance_private (pebbles_statistics_graph_type_id, sizeof (PebblesStatisticsGraphPrivate));
	return pebbles_statistics_graph_type_id;
}

GType
pebbles_statistics_graph_get_type (void)
{
	static volatile gsize pebbles_statistics_graph_type_id__volatile = 0;
	if (g_once_init_enter (&pebbles_statistics_graph_type_id__volatile)) {
		GType pebbles_statistics_graph_type_id;
		pebbles_statistics_graph_type_id = pebbles_statistics_graph_get_type_once ();
		g_once_init_leave (&pebbles_statistics_graph_type_id__volatile, pebbles_statistics_graph_type_id);
	}
	return pebbles_statistics_graph_type_id__volatile;
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

